@ECHO OFF
color 1f
cls
:: HISTORY  [(c)2017 SSi]
:: MakePartitionImage v0.002 2014-04-13 First version
:: 0.004 - bugfix for some isolinux ISOs like dsl which have no vesamenu.c32 file.
:: 0.005 - change menu.lst options, asks for volume label
:: 0.006 - add autorun.inf to show ISO name
:: 0.007 - payload file name inserted into CSM menu
:: 0.008/9 - using winrar
:: 0.010 - using 7zip first and then winrar if not successful (user must add winrar)
:: 0.011 - uses installed winRar or PowerISO, copies CUSTOM folder
:: 0.012 - more linux fixups added. QUIET option added for fixups.  BUG!
:: 0.013 - bugfix! Fixups not done in QUIET mode in 0.012!
:: 0.014 - fix issue if iso had a space in filename
:: 0.015 - support YUMI images, get vol name changed, path parsing improved
:: 0.016 - sizing of folder fixed, menu.lst custom tweaked.
:: 0.017 - use fsutil for volume label and fix echo bug in 0.016
:: 0.018 - improve menu.lst, tidy up code, bugfix for dsl and others which use \boot\isolinux folder
:: 0.019 - Add size of custom folder to image size calculation, bugfix if xcopy fails when copying CUSTOM files, syslinux 6 added, now updates chain.c32 if present
:: 0.020 - install of syslinux fixed for syslinux v5 and 6 - needs linux / in path! extra .c32 files added
:: 0.021 - menu.lst now shows EFI boot files under menu
:: 0.022 - new aurora background, E2B can be on hd0,1 or hd0,0
:: 0.023 - reduce amount of wasted free space, free space shown, check for zip/7z file and adjust size, AUTORUN switch added
:: 0.025 - getsparevol bugfix - if U: was in use (e.g. empty CDROM) it caused a problem! clear screen, improve filespec input (can use J: or j:\ or filespec with or without quotes)
:: 0.026 - PAYLOAD variable modified so PAYLOAD= does not appear in menu if left unmodified, increase image size for larger payloads - e.g. 2GB Windows install ISOs.
:: 0.027 - Imdisk images set to 255x63 geometry
:: 0.028 - bugfix for small source files (default .imgPTN name was not suggested)
:: 0.029 - changed syslinux for \system and \system\isolinux, set cmd console window size, 0.029a folder path need not end in \ now
:: 0.030 - Clover UEFI boot support added to menu.lst
:: 0.031 - Clover Lite added, auto-shortcut cmd file added to generate Desktop shortcuts (use set NOCLOVER=1 to not add clover to images)
:: 0.032 - 64-bit Clover files added - it is no longer necessary to add the separate Clover Pack 
:: 0.033 - Clover \EFI\CLOVER\config.plist file changed to support Asus Haswell-based systems, for older Asus systems, rename config.plist.Asus to config.plist
:: 0.034 - HP utilities can use syslinux 4 now - will work from ISO (LREMOVE.cmd also modified)
:: 0.035 - Windows NTFS+FAT32 ptns can be UEFI booted using Clover, bugfix for syslinux in csm menu when should not be there (PBR.bin)
:: 0.036 - fix for weird characters like & in filenames or paths (use !xxx! instead of %xxx% for files)
:: 0.037 - fix for weird characters in pathnames by using ! instead of %
:: 0.038 - change default volume name to EASY2BOOT
:: 0.039 - LREPLACE.cmd now replaces findiso if at start of newline (e.g. in UEFI_Fedora-17-i686-Live-SoaS.iso bootia32.conf file)
:: 0.040 - Increase size of NTFS partition, change Free Space WMIC code (/Format:CSV only works on en-US system!)
:: 0.041 - Typo fix for CUST_SIZE-CLOVER_SIZE (thanks Vlad!), double-check for spare drive letter using Net Use (thanks Vlad!), use df.exe for free space report instead if wmic
:: 0.042 - Typo fixes - copy from volume\CD fix (thanks Stephan!)
:: 0.043 - Acronis mmenu addition
:: 0.044 - FreeBSD support added (memstick.img)
:: 0.045 - if Windows Install detected, swaps hd0 and hd1 so can install in a VM. (csm\menu.lst)
:: 0.046 - LREPLACE now replace by-label volume label (e.g. eset rescue syslinux)
:: 0.047 - menu.lst - fix freeldr.sys, add EasyRE Win10 kernel /bootmgr 
:: 0.048 - new hotkey added, grub4dos 0.4.6a
:: 0.051 - no changes to this file (mainly menu.lst changes) + Clover 32-bit added
:: 0.052 - no changes to this file, menu.lst now detects grub2\syslinux in (hd0,2) partition
:: 0.053 - no changes to this file, menu.lst now has MBR.BIN reserve backup MBR
:: 0.054 - bugfix to prevent running ssed on binary files in LREPLACE.cmd
:: 0.055 - Switch_e2b.exe added, new imdiskinst.exe version
:: 0.056 - New ImDisk version for Win10 Threshold 2 - 057 new Switch_e2B version
:: 0.061 - bugfix in LREPLACE.CMD
:: 0.062 = new .7z
:: 0.063 - return to old .7z (new one reports error on some isos), csm menu.lst modified
:: 0.064 - bugfix in csm\menu.lst for syslinux booting
:: 0.065 - usb --init driver menu entry added to csm menu.lst, grldr 20160326
:: 0.066 - csm\menu.lst change for pbr.bin, new SWITCH_E2B.exe v1.0.11
:: 0.067 - support for \MyCSM.cfg file (and \e2b\message file for GFXBoot menu) - new grldr
:: 0.068 - menu.lst copies AutoUnattend.xml to WinHelper file
:: 0.069 - menu.lst now checks if hd0, 4GB FAT32 warning added
:: 0.070 - added MBRFix self-extracting exes for 32-bit and 64-bit
:: 0.071 - LREPLACE.cmd change for porteus changes= to fix bug
:: 0.072 - SWITCH_E2B.exe v1.0.13 updated, menu.lst tweaked
:: 0.073 - add Imdisk -o hd switch. CreateDesktopShortcuts.cmd changed to work with latest Windows 8/10 (vbscript bug introduced by KB4015438)
:: 0.074 - bugfix for menu.lst, improve syslinux detect
:: 0.075 - bugfix for 0.074 menu.lst heading
:: 0.076 - ask syslinux version always, don't install syslinux to PBR but make \syslinux.bin file
:: 0.077 - exclude some files when using xcopy
:: 0.078 - change checkperms subroutine, change getsparev subroutine, tweak menu.lst for FreeBSD ISOs
:: 0.079 - modify menu.lst clover menu from skip/seek 87 to 90, change Desktop code in CreateDesktopShortcuts, fix menu.lst for freebds 3rd ptn detection
:: 0.080 - bugfix for when \syslinux.cfg or \isolinux.cfg in root, new Switch_e2b.exe
:: 0.081 - bugfix for grub4dos 0.4.6a MBR in menu.lst
:: 0.082 - Add Split_WinISO, add timeout+default menu and other small changes to menu.lst, new glrdr version, new clover 64-bit
:: 0.083 - pause if no target specified by user, add AUTOSYSL to use default syslinux version detected, use 7z.exe to calculate disk space required
:: 0.084 - csm\menu.lst now looks for "GRUB" in PBR of (hd0,2)
:: 0.085 - change menu.lst for language support using new grub4dos
:: 0.086 - bugfix to RestoreE2B_32_64.cmd (helper) search, change blank colour in menu.lst to 0000 from 0122.
:: 0.087 - If EFI.img file found and no EFI boot files present, extract EFI boot files
:: 0.088 - use 7z instead of 7zg, extract files from .img files in \[BOOT] folder, sylinux modified, test for slax syslinux added, added syslinux v6.03, default to v4 if syslinux 3 due to only default paths searched by v3 for syslinux.cfg
:: 0.089 - fix menu.lst for hotkeys not working in text mode menu, added \heading.g4b to set default menu heading
:: 0.090 - add Restore_E2B.sh linux script, list install.* if FAT32 extraction fails, turn of key help in CSM menu.lst file
:: 0.091 - use -oas switch with 7zip extract from image files, install ImDisk if not already installed
:: 0.092 - bugfix under :SPrf label if no files in image
:: 0.093 - rEFInd added, copy bootmgfw.efi to bootx64.efi if missing for win7, tweak syslinux versions
:: 0.094 - rEFInd ext2/4 drivers added, bugfix for drag-and-drop folder
:: 0.095 - add DLC 2019 support, add syslinux 604pre1 (pre4 did not work)
:: 0.096 - add Czech language for CSM menu, add E2B_Editor to MPI folder, KBD variable is now recognised to set KBD type, latest grub4dos, add all KBD translation files.
:: 0.097 - check for .sig files and don't autoconvert, slovenian csm language added
:: 0.098 - new SWITCH_E2B.exe, menu.lst updated (added .conf fix for paldo img files)
:: 0.099 - new SWITCH_E2B.exe,
:: 0.100 - new Switch_e2b.exe
:: 0.101 - new Switch_e2b.exe 1.1.35 with recursive bug fix
:: 0.102 - Switch_E2b.exe 1.1.36 drive enumeration bugfix
:: 0.103 - default to .imgptn23 instead of .imgptn
:: 0.104 - LREPLACE.cmd  use CDLABEL instead of LABEL if OpenSuse
:: 0.105 - Add DLC1 2022 mod (must use .imgPTN not .imgPTN23)

pushd "%~dp0"

set MPV=MPI Version 0.105 2022-08-27 [SSi]

TITLE %MPV%
echo %MPV%

:: set cmd shell window size
mode con: cols=120 lines=60

setlocal EnableDelayedExpansion

:: Make IMG and mount it
:: extract ISO or folder to new drive
:: unmount IMG

:: comment the next line to show user all linux config string replacements and .conf fixups
set QUIET=
if "%NOISY%"=="" set QUIET=^>nul

:: uncomment this to log all linux config string replacements and .conf fixups (only to send log report - delete MPI_REPLACE.log file before each run)
:: set QUIET=^>^> MPI_REPLACE.log

:: if the NOEXPLORER variable exists then Explorer will not be launched.

:: get user params
set MYSOURCE="%~1"
set MYIMG="%~2"
set MYFMT=%~3
set MYSIZE=%~4
set MYVOL=%~5
set MYTITLE=%~6

:: NOTE: MYSOURCE and MYIMG are in double-quotes

:: if invalid 3rd parameter then set rest to blank
if /i not "%MYFMT%"=="NTFS" if /i not "%MYFMT%"=="FAT32" (set MYFMT=& set MYSIZE=& set MYVOL=)

:: if no 5th param, set default MYVOL 
if not "%~4"=="" if "%~5"=="" (set MYVOL=EASY2BOOT)

echo.
if not "%MYFMT%"=="" goto :skipu

echo Usage:   %~n0: [SOURCE] [TARGET] [NTFS ^| FAT32] [SIZE MB ^| *] {VOL_NAME} {CSM MENU TITLE}
echo.
echo SOURCE = ISO or ZIP file or Folder or Drive (e.g. C:\ubuntu.iso, J:\)
echo TARGET = New Partition Image file to create (e.g. C:\temp\new.imgPTN23)
echo.
echo Remember to use double-quotes for filenames! * = use suggested size\target name.
echo.
echo Examples:
echo %~n0 "C:\temp\afile.iso"  "C:\temp\NEW.imgPTN23"  FAT32 1200 MYLABEL NEWIMAGE
echo %~n0 "C:\temp\afile.iso"   * NTFS * 
echo %~n0 "C:\temp\afile.iso"   * NTFS 1070
echo %~n0 "F:\"  
echo %~n0 "C:\temp\somefolder\"  
echo.
:skipu

:: if error DONE will be clear
set DONE=

echo %~n0: Creates a grub4dos partition image file from an ISO or folder
echo.
::call :check_Permissions
call :checkperms
if "%ADMIN%"=="FAIL" goto :EOF

if not exist "%SystemRoot%\system32\IMDISK.EXE" call .\imdisk\imdiskinst.exe

if not exist "%SystemRoot%\system32\IMDISK.EXE" echo. & echo ERROR: ImDisk is not installed! Please read the ReadMe.txt file. & color cf & pause & goto :EOF

:: Look for a spare drive letter
call :getsparev
if "%SPAREVOL%"=="" echo Can't find an spare driveletter to mount new drive on. & pause & goto :EOF



echo Tip: Use TAB key to complete path and save typing!
echo.


:: --- GET SOURCE ----
if !MYSOURCE!=="" set /P MYSOURCE=Source ISO or Folder (e.g. C:\temp\fred.iso) : 
if !MYSOURCE!==""  goto :EOF

if "%NOISY%"=="" CLS

:: get full path of file in double-quotes
call :getfp !MYSOURCE!
set MYSOURCE=%FP%

:: full path will be in quotes now

if not exist !MYSOURCE! setlocal DisableDelayedExpansion & echo ERROR: File %MYSOURCE% does not exist! & echo Check this path is correct (WARNING: the character "!" must not be used). & pause & goto :eof
:: note: line below should never trap cos J: is turned into "J:\" by the getfp call
if "%MYSOURCE:~-2,1%"==":" echo BAD FILESPEC: To copy a whole volume please use a backslash - e.g. X:\   & pause & goto :EOF
echo.
echo  ===^> SOURCE:  !MYSOURCE!


:: --- GET FILESYSTEM TYPE ---
:: make uppercase if exist
if /i "%MYFMT%"=="NTFS" set MYFMT=NTFS& goto :skpfmt
if /i "%MYFMT%"=="FAT32" set MYFMT=FAT32& goto :skpfmt
echo.
echo Choose a FileSystem:
echo.
echo FAT32 will support UEFI and MBR booting.
echo NTFS  will only support MBR booting (but can contain files larger than 4GB).
echo.
echo Note: For UEFI booting you must use FAT32.
echo.
echo       A = Abort
echo.
set ask=
if not "%AUTORUN%"=="Y" set /p ask=Use FAT32 for new image (N=NTFS) (A/[Y]/N) : 
if /i "%ask%"=="A" goto :eof
set MYFMT=FAT32
if /i "%ask%"=="N" set MYFMT=NTFS
:skpfmt

if "%NOISY%"=="" CLS


echo                                            %MYFMT% selected
echo.
:: ---------- REFIND ----------
:: Ask user if they want to add REFIND and SWITCH_X64.wim file so they can change .imgPTN files from UEFI-boot
if /i not "%MYFMT%"=="FAT32" goto :CCr
if not exist "%~dp0REFIND\REFIND.cmd" goto :CCr
if "%DOWIM%"=="1" if not exist "%~dp0CUSTOM_PE\SOURCES\*.wim" echo ERROR: No CUSTOM_PE\SOURCES\*.wim file found & pause & goto :CCr
if "%DOREFIND%"=="1" goto :CCr
echo.
@echo ADD REFIND (FOR MULTI-UEFI BOOTING)?
@echo ====================================
@echo.
@echo Note: If you add rEFInd you will only be able to Secure Boot by using MokManager
@echo.
@echo 1 or N = No rEFInd (default)
@echo 2 or R = Add rEFInd UEFI multi-boot menu (no Secure Boot)
if exist "%~dp0CUSTOM_PE\SOURCES\*.wim" echo 3 or W = Add rEFInd UEFI multiboot menu + WinPE x64
@echo.
@echo.
@echo TIMEOUT IN 30 SECONDS...   (default=No rEFInd)
@echo.
::Ask user with timeout
set REF=
if not exist "%~dp0CUSTOM_PE\SOURCES\*.wim" choice /c 1N2R /N /D N /T 30 /M "Add Multi-UEFI support ([1]/2/N/R)? : "
if exist "%~dp0CUSTOM_PE\SOURCES\*.wim" choice /c 1N2R3W /N /D N /T 30 /M "Add Multi-UEFI support ([1]/2/3/N/R/W)? : "
@echo.
if "%ERRORLEVEL%"=="1" set DOWIM=&  set DOREFIND=&set REF=(No rEFInd)
if "%ERRORLEVEL%"=="2" set DOWIM=&  set DOREFIND=&set REF=(No rEFInd)
if "%ERRORLEVEL%"=="3" set DOWIM=0& set DOREFIND=1&set "REF=^+ rEFInd"
if "%ERRORLEVEL%"=="4" set DOWIM=0& set DOREFIND=1&set "REF=^+ rEFInd"
if "%ERRORLEVEL%"=="5" set DOWIM=1& set DOREFIND=1&set "REF=^+ rEFInd ^+ WinPE"
if "%ERRORLEVEL%"=="6" set DOWIM=1& set DOREFIND=1&set "REF=^+ rEFInd ^+ WinPE"
@echo.
if "%NOISY%"=="" CLS
echo                                            %MYFMT% %REF% selected
echo.
set REF=
:CCr

:: if ends with \ then it is a folder not a ISO or file
if "%MYSOURCE:~-2,1%"=="\" goto :fld
dir %MYSOURCE% /ad 2>NUL >NUL && goto :fld

:: --- GET SOURCE FILE SIZE ---
:: get file extension - if none assume folder
call :getext !MYSOURCE!
if "%EXT%"=="" goto :fld

:: MYSOURCE is a file

call :getsz !MYSOURCE!
:: SZ has size in bytes
:: if 0 then it is folder
set ISOSZ=%SZ%
echo.
echo !MYSOURCE! requires approx. %ISOSZ:~0,-6%MB of disk space
echo.
:: assume folder if size less 40K (if folder get 4096 returned on NTFS 4K per cluster system)
if %ISOSZ% LEQ 40000 goto :fld
::echo SZ=%SZ% & pause
if "%ISOSZ%"=="0" goto :fld
if "%ISOSZ%"=="1" goto :fld
if "%ISOSZ%"=="" goto :fld
:: convert bytes to MB
set ISOSZ=%SZ:~0,-6%
:: add 1 for lost  and 3 more in case small file which seems to need more
set /a ISOSZ=ISOSZ+4
if "%ISOSZ%"=="" set ISOSZ=2
if "%ISOSZ%"=="0" set ISOSZ=2
set SUG_SIZE=%ISOSZ%
set ORIG_SIZE=%ISOSZ%
goto :getsz1



:: --- GET SOURCE FOLDER SIZE ---
:Fld
echo Finding size of folder !MYSOURCE! - please wait...
.\UTILS\DIRUSE.exe !MYSOURCE! > myvol.log
for /F "usebackq tokens=1" %%A in (`find "  TOTAL: " myvol.log`) do set SUG_SIZE=%%A
set SUG_SIZE=%SUG_SIZE:~0,-6%
echo !MYSOURCE! is approx. %SUG_SIZE%%MB in size
set ORIG_SIZE=%SUG_SIZE%
set ISOSZ=0
REM add a bit for luck!
set /a SUG_SIZE=SUG_SIZE+5

:: if a drive was specified and not a folder then set volume label
if "%MYSOURCE:~-3,2%"==":\" call :getvol %MYSOURCE:~1,2%

:: --- ASK SIZE OF IMAGE FILE
:getsz1
:: SUG_SIZE has size of payload in MB
if "%ISOSZ%"=="" set ISOSZ=0

@echo.
:: Add our CSM Folder size
.\UTILS\DIRUSE.exe .\CSM\ > myvol.log
for /F "usebackq tokens=1" %%A in (`find "  TOTAL: " myvol.log`) do set CSM_SIZE=%%A
set CSM_SIZE=%CSM_SIZE:~0,-6%
set /a CSM_SIZE=CSM_SIZE+1
echo CSM Folder        = %CSM_SIZE%MB
set /a SUG_SIZE=SUG_SIZE+%CSM_SIZE%

:: Add CUSTOM Folder size
.\UTILS\DIRUSE.exe .\CUSTOM\ > myvol.log
for /F "usebackq tokens=1" %%A in (`find "  TOTAL: " myvol.log`) do set CUST_SIZE=%%A
set CUST_SIZE=%CUST_SIZE:~0,-6%
set /a CUST_SIZE=CUST_SIZE+1
echo CUSTOM Folder     = %CUST_SIZE%MB
set /a SUG_SIZE=SUG_SIZE+%CUST_SIZE%

:: Add CLOVER Folder size
if "%NOCLOVER%"=="1" goto :skpclov
.\UTILS\DIRUSE.exe .\CLOVER\CSM\ > myvol.log
for /F "usebackq tokens=1" %%A in (`find "  TOTAL: " myvol.log`) do set CLOVER_SIZE=%%A
set CLOVER_SIZE=%CLOVER_SIZE:~0,-6%
set /a CLOVER_SIZE=CLOVER_SIZE+1
echo CLOVER Folder     = %CLOVER_SIZE%MB
set /a SUG_SIZE=SUG_SIZE+%CLOVER_SIZE%
:skpclov

:: Add REFIND Folder size
if not exist .\REFIND\nul goto :skprefind
if NOT "%DOREFIND%"=="1" goto :skprefind
.\UTILS\DIRUSE.exe .\REFIND\ > myvol.log
for /F "usebackq tokens=1" %%A in (`find "  TOTAL: " myvol.log`) do set REFIND_SIZE=%%A
set REFIND_SIZE=%REFIND_SIZE:~0,-6%
set /a REFIND_SIZE=REFIND_SIZE+1
echo REFIND Folder     = %REFIND_SIZE%MB
set /a SUG_SIZE=SUG_SIZE+%REFIND_SIZE%

if not exist .\CUSTOM_PE\sources\*.wim goto :skprefind
if NOT "%DOWIM%"=="1" goto :skprefind
:: Add WIM file
.\UTILS\DIRUSE.exe .\CUSTOM_PE\SOURCES\ > myvol.log
for /F "usebackq tokens=1" %%A in (`find "  TOTAL: " myvol.log`) do set WIM_SIZE=%%A
set WIM_SIZE=%WIM_SIZE:~0,-6%
:: add 5MB because we will make a copy of .efi file and allow for a bit more room!
set /a WIM_SIZE=WIM_SIZE+5
echo CUSTOM_PE folder  = %WIM_SIZE%MB
set /a SUG_SIZE=SUG_SIZE+%WIM_SIZE%

:skprefind

echo.
:: Add xMB to allow for extra syslinux folder/files, etc.
::set /a SUG_SIZE=SUG_SIZE+7
:: Add 0.4% for FAT filesystem overhead
set /a SUG_SIZE=SUG_SIZE+SUG_SIZE/250
:: add overhead for NTFS, etc.
if "%MYFMT%"=="NTFS"                         set /a SUG_SIZE=SUG_SIZE+28
:: if large ISO e.g. Win install we need more space
::if %SUG_SIZE% GEQ 1000                       set /a SUG_SIZE=SUG_SIZE+25
::if %SUG_SIZE% GEQ 2000                       set /a SUG_SIZE=SUG_SIZE+40
::if %SUG_SIZE% GEQ 3000                       set /a SUG_SIZE=SUG_SIZE+40
::if %SUG_SIZE% GEQ 4000                       set /a SUG_SIZE=SUG_SIZE+50

:: Min is 38MB for ImDisk
if not %SUG_SIZE% GEQ 38                     set SUG_SIZE=38

:: get file extension
call :getext !MYSOURCE!
::if /i "%EXT%"==".ZIP" echo ATTENTION: This %ISOSZ%MB is compressed - Please CHECK SIZE & echo. & set /a SUG_SIZE=SUG_SIZE*6  & set /a SUG_SIZE=SUG_SIZE/5
::if /i "%EXT%"==".7Z"  echo ATTENTION: This %ISOSZ%MB is compressed - Please CHECK SIZE & echo. & set /a SUG_SIZE=SUG_SIZE*6  & set /a SUG_SIZE=SUG_SIZE/5

::if "%MYFMT%"=="NTFS" echo Tip: If formatting as a large NTFS volume, you may need extra space
::echo                     Suggested %MYFMT% size=%SUG_SIZE%  (press ENTER for this size)
echo Suggested %MYFMT% size=%SUG_SIZE%  (press ENTER for this size)
::echo.
:: If user entered * then use suggested size
if "%MYSIZE%"=="*" set MYSIZE=%SUG_SIZE%
echo.
echo.
if not "%SUG_SIZE%"=="" if "%MYSIZE%"=="" set /p MYSIZE=Size for Image file (MB), min=38 - e.g. [%SUG_SIZE%] : 
if     "%SUG_SIZE%"=="" if "%MYSIZE%"=="" set /p MYSIZE=Size for Image file (MB), min=38 : 

SET "var="&for /f "delims=0123456789" %%i in ("%MYSIZE%") do set var=%%i
if defined var (echo ERROR: %MYSIZE% IS NOT NUMERIC - PLEASE USE A NUMBER) & pause & set MYSIZE=& set SUG_SIZE=& goto :getsz1
set var=

if "%MYSIZE%"==""  set MYSIZE=%SUG_SIZE%
if "%MYSIZE%"=="" goto :EOF
:: FAT32 volumes below 38MB won't format!
if not %MYSIZE% GEQ 38 set MYSIZE=38
set /a MYSIZE=MYSIZE+0
if "%MYSIZE%"=="" set MYSIZE=38
if "%MYSIZE%"=="0" set MYSIZE=38
:: MYSIZEK is size in KB
set MYSIZEK=%MYSIZE%000
:: get size of file in KB (if folder then this will be null)
set SZK=%SZ:~0,-3%
set /a SZK=SZK+0
if "%SZK%"=="" set SZK=0
if %SZK% GEQ %MYSIZEK% echo. && color cf & echo ERROR: File is %SZK%KB and is bigger than %MYSIZEK%KB & pause & goto :EOF

if "!MYIMG!"==""*"" goto :skpstar
if not !MYIMG!=="" goto :skpmi




:: --- REQUEST FILENAME FOR TARGET IMAGE ---
:skpstar

if "%NOISY%"=="" CLS

TITLE %MPV% - OUTPUT FILENAME
echo.
echo .IMGPTN   - will remove Partition 2 and Partition 3 (best for Legacy booting)
echo .IMGPTN23 - will *keep*  Partitions 2 (and 3 if present) - recommended for UEFI booting
echo.
echo ENTER OUTPUT FILENAME (e.g.  "C:\temp\fred.imgPTN23")
echo.
set SUG_NAME=
:: if it is a file suggest a filename
:: ISOSZ=0 if a folder

if %ISOSZ% GEQ 2 call :getfname !MYSOURCE!
if %ISOSZ% GEQ 2 set SUG_NAME=!FN!.imgPTN23
if "!MYIMG!"==""*"" if %ISOSZ% GEQ 2 set MYIMG=!SUG_NAME!& goto :gotnm1
set MYIMG=
if %ISOSZ% GEQ 2 echo. & echo. & echo For the default - press the [ENTER] key& echo. & echo DEFAULT = !SUG_NAME! 
echo.
set /p MYIMG=OUTPUT FILENAME for new Image (e.g. C:\temp\xxx.imgPTN23) : 
:gotnm1
if "!MYIMG!"=="" if "!SUG_NAME!"=="" echo ERROR: No output file was specified!  & pause & goto :EOF
if "!MYIMG!"=="" set MYIMG=!SUG_NAME!
if "!MYIMG!"=="" echo ERROR: No output file was specified!  & pause & goto :EOF
if "!MYIMG!"=="""" echo ERROR: No output file was specified!  & pause & goto :EOF
:: ensure LFN is quoted by calling getfp - it will remove "" if present
call :getfp "!MYIMG!"
set MYIMG=!FP!

:: --- REQUEST VOLUME NAME ---

:skpmi
if not "%MYVOL%"=="" goto :skpvol
set ask=
echo.
if not "%AUTORUN%"=="Y" set /p MYVOL=VOLUME NAME for partition image - max 11 chars. [EASY2BOOT] : 
if "%MYVOL%"=="" set MYVOL=EASY2BOOT
set MYVOL=%MYVOL:~0,11%
if "%MYVOL%"=="" set MYVOL=EASY2BOOT
:skpvol




:: --- DISPLAY PARAMETERS AND CREATE IMAGE ---

if "%NOISY%"=="" CLS
echo.
echo SOURCE      = !MYSOURCE!
echo NEW IMAGE   = !MYIMG!
echo NEW DRIVE   = %SPAREVOL%
echo FORMAT      = %MYFMT%
echo VOLUME NAME = %MYVOL%
echo IMAGE SIZE  = %MYSIZE%MB  (Source=%ORIG_SIZE%MB)
echo.

:: check full path of source again, just in case!
call :getfp !MYSOURCE!
if not %ISOSZ% GEQ 2 if not "%MYSOURCE:~-2,1%"=="\" call :getfp !MYSOURCE!\
set MYSOURCE=%FP%


if not %ISOSZ% GEQ 2 if not "%MYSOURCE:~-2,1%"=="\" echo ERROR: SOURCE FOLDER (!MYSOURCE!) MUST END IN BACKSLASH, e.g. G:\ or F:\FRED\ or "D:\name and space\" & pause & goto :EOF

TITLE %MPV% - Mount !MYIMG!
ECHO CREATING AND MOUNTING NEW DRIVE %SPAREVOL% as !MYIMG!
ECHO.

if exist !MYIMG! echo Deleting !MYIMG!... & del !MYIMG! 
if exist !MYIMG! echo. & echo. & color 4f & echo ERROR: Could not delete !MYIMG! - Please remove virtual drive from ImDisk & start imdisk.cpl & pause & goto :unmount

::Create disk image C:\my_disk.ima (superfloppy format) 2104515 sectors in size (1.5 GB) and mount as drive R:, then format using compressed NTFS
echo Running: imdisk -a -s %MYSIZE%m -o hd -m %SPAREVOL% -f !MYIMG! -x 63 -y 255 -p "/FS:%MYFMT% /Q /Y"
              imdisk -a -s %MYSIZE%m -o hd -m %SPAREVOL% -f !MYIMG! -x 63 -y 255 -p "/FS:%MYFMT% /Q /Y" > imdisk.log
if errorlevel 1 type imdisk.log & echo ImDisk operation failed to mount !MYIMG!! & pause & goto :unmount

:: delay for 4 seconds for volume to be mounted, etc.
PING -n 4 127.0.0.1>nul

:: get FAT and NTFS UUIDs
pushd "%~dp0UTILS"
call GET_UUID_NTFS.cmd %SPAREVOL%
call GET_UUID_FAT32.cmd %SPAREVOL%
REM Check for bad FAT32 UUID - warn and get UUID_FAT32 again
if "%UUID_FAT32%"=="0000-0000" echo WARNING: Bad Volume %SPAREVOL% UUID - please use a normal physical hard disk volume (not a virtual drive such as a Microsoft Storage Pool or software RAID volume)& pause & call GET_UUID_FAT32.cmd %SPAREVOL%
set UUID=%UUID_FAT32%
if "%MYFMT%"=="NTFS" set UUID=%UUID_NTFS%
popd

echo IMAGE MOUNTED AS DRIVE %SPAREVOL% (UUID=%UUID%)

:: ---  COPY FILES TO MOUNTED IMAGE ---

TITLE %MPV% - Extract !MYSOURCE! to "%SPAREVOL%\"
echo.
echo Copying files from !MYSOURCE! to "%SPAREVOL%\"
echo Please wait... & echo.


if not %ISOSZ% GEQ 2 goto :dd
echo Running .\7z\7z.exe  x -y !MYSOURCE! -o%SPAREVOL%\
.\7z\7z.exe  x -y !MYSOURCE! -o%SPAREVOL%\  

:: 7zip gives errorlevel 2 if not enough space or extra data which was not extracted
echo ERRORLEVEL %errorlevel%
echo.
if errorlevel 2 goto :bade
if errorlevel 1 goto :PISO
if not exist %SPAREVOL%\readme.txt goto :notudf

:: Check 7zip didn't extract the non-UDF part of a UDF ISO
find "This disc contains a "   %SPAREVOL%\readme.txt > nul & if errorlevel 1 goto :notudf
find "UDF"                     %SPAREVOL%\readme.txt > nul & if errorlevel 1 goto :notudf
find "supports the ISO-13346 " %SPAREVOL%\readme.txt > nul & if errorlevel 1 goto :notudf
:: -- 7ZIP FAILED as UDF format ISO - clean up and try something else!
if exist %SPAREVOL%\readme.txt del %SPAREVOL%\readme.txt > nul
:: about to delete all files - check no accidents!
if "%SPAREVOL%"=="" goto :bade
if "%SPAREVOL%"=="C:" goto :bade
if exist "%SPAREVOL%\Windows\nul" goto :bade
rd /S /Q %SPAREVOL%\ > nul


:PISO
:: use powerISO to extract UDF
echo Trying PowerISO...
if exist "C:\Program Files\PowerISO\piso.exe" "C:\Program Files\PowerISO\piso.exe" extract !MYSOURCE! / -od %SPAREVOL%\  & if not errorlevel 1 goto :dd
if exist "C:\Program Files (x86)\PowerISO\piso.exe" "C:\Program Files (x86)\PowerISO\piso.exe" extract !MYSOURCE! / -od %SPAREVOL%\ & if not errorlevel 1 goto :dd
echo PowerISO not found or failed to extract files, trying WinRAR...

:winrar
set WINRAR=xxx
echo Trying WinRar...
if  exist "C:\Program Files\WinRAR\winrar.exe" set WINRAR="C:\Program Files\WinRAR\winrar.exe" 
if  exist "C:\Program Files (x86)\WinRAR\winrar.exe" set WINRAR="C:\Program Files (x86)\WinRAR\winrar.exe" 
if not exist %WINRAR% color 4f & echo. & echo ATTENTION: This UDF ISO file needs to be extracted using WinRAR or PowerISO - please install one of them and try again. & pause & goto :unmount

:: use winrar as can deal with UDF format ISOs
%WINRAR% x !MYSOURCE! %SPAREVOL%\ & if not errorlevel 1 goto :dd
set WINRAR=

:bade
color 4f
echo.
echo WARNING: There was a problem extracting files from !MYSOURCE! to %SPAREVOL%!
echo Try extracting the contents to a folder using ISOBUSTER or UltraISO.
echo.
:: check for large install.* file (cannot test 4GB size as only 32-bit signed maths)
if "%MYFMT%"=="FAT32" if exist !SPAREVOL!\sources\install.wim echo INFO:    !SPAREVOL!\sources\install.wim exists
if "%MYFMT%"=="FAT32" if exist !SPAREVOL!\sources\install.esd echo INFO:    !SPAREVOL!\sources\install.esd exists
if "%MYFMT%"=="FAT32" if exist !SPAREVOL!\x64\sources\install.wim echo INFO:    !SPAREVOL!\x64\sources\install.wim exists
if "%MYFMT%"=="FAT32" if exist !SPAREVOL!\x64\sources\install.esd echo INFO:    !SPAREVOL!\x64\sources\install.esd exists
if "%MYFMT%"=="FAT32" if exist !SPAREVOL!\x32\sources\install.wim echo INFO:    !SPAREVOL!\x32\sources\install.wim exists
if "%MYFMT%"=="FAT32" if exist !SPAREVOL!\x32\sources\install.esd echo INFO:    !SPAREVOL!\x32\sources\install.esd exists
if "%MYFMT%"=="FAT32" echo INFORMATION: The maximum file size for FAT32 is 4,294,967,295 bytes (4GB).
if "%MYFMT%"=="FAT32" echo Please ensure each file inside the source file\folder is smaller than 4GB, or use NTFS instead of FAT32.
if "%MYFMT%"=="FAT32" .\7z\7z.exe  l -r !MYSOURCE! install.*
if "%MYFMT%"=="FAT32" echo. && echo You can split an install.wim/install.esd file to make a .imgPTN file - use 'Split WinISO.exe' and click on 'Convert'

echo.
set ask=
set /p ask=Abort making the image? ^([Y]/N^) : 
if /i not "%ask%"=="N" goto :unmount

:notudf
:dd

:: -------  XCOPY IF SOURCE IS A FOLDER
if %ISOSZ% GEQ 2 goto :dd1
if "%MYSOURCE:~-3,2%"==":\" xcopy /qherkyfi !MYSOURCE!* %SPAREVOL%\ /EXCLUDE:XCOPY_EXCLUDE.txt & if errorlevel 1 color 4f & echo MAY NEED MORE SPACE? & pause & goto :unmount
::if not "%MYSOURCE:~-3,2%"==":\" xcopy /qherkyfi "%MYSOURCE:~1,-2%" %SPAREVOL%\ & if errorlevel 1 color 4f & echo MAY NEED MORE SPACE? & pause & goto :unmount
if not "%MYSOURCE:~-3,2%"==":\" xcopy /qherkyfi "!MYSOURCE:~1,-2!\*.*" %SPAREVOL%\  /EXCLUDE:XCOPY_EXCLUDE.txt & if errorlevel 1 color 4f & echo MAY NEED MORE SPACE? & pause & goto :unmount

:dd1


:: --- TIDY UP COPIED FILES

:: Extract [BOOT] files (may have syslinux folder and EFI boot files) - don't overwrite exisiting files -aos
if exist %SPAREVOL%\[BOOT]\*.img .\7z\7z x -y -aos %SPAREVOL%\[BOOT]\*.img -o%SPAREVOL%\ 3>NUL 2>NUL >NUL
:: remove [BOOT] folder if it was in the ISO as not needed (keep as may be able to extract boot files from it)
if exist %SPAREVOL%\[BOOT]\*  rd /s /q %SPAREVOL%\[BOOT] > nul
echo.

:: --- EXTRACT FROM EFI.img ---
if exist %SPAREVOL%\EFI\BOOT\*.EFI goto :skpefi
REM No EFI boot files, so add them
set EFI_FILE=%SPAREVOL%\EFI.IMG
if exist %EFI_FILE% goto :gotefi
set EFI_FILE=%SPAREVOL%\BOOT\EFI.IMG
if exist %EFI_FILE% goto :gotefi
set EFI_FILE=%SPAREVOL%\BOOT\GRUB\EFI.IMG
if exist %EFI_FILE% goto :gotefi
set EFI_FILE=%SPAREVOL%\EFIBOOT.IMG
if exist %EFI_FILE% goto :gotefi
set EFI_FILE=%SPAREVOL%\BOOT\EFIBOOT.IMG
if exist %EFI_FILE% goto :gotefi
set EFI_FILE=%SPAREVOL%\BOOT\GRUB\EFIBOOT.IMG
if exist %EFI_FILE% goto :gotefi
goto :skpefi

:gotefi
if not exist %EFI_FILE% goto :skpefi
if exist "%TEMP%\EFI" rd /s /q "%TEMP%\EFI" > nul
if exist "%TEMP%\EFI" goto :skpefi
mkdir "%TEMP%\EFI"
.\7z\7z.exe  x -y -aos %EFI_FILE% -o"%TEMP%\EFI\" > nul
:: 7zip gives errorlevel 2 if not enough space or extra data which was not extracted
if not exist "%TEMP%\EFI\EFI\BOOT\*.efi" goto :skpefi
echo Deleting %EFI_FILE%...
del %EFI_FILE%
echo Extracting EFI boot files from %EFI_FILE%...
xcopy /cherky "%TEMP%\EFI\*" %SPAREVOL%\ > nul
dir /b %SPAREVOL%\EFI\BOOT\
echo.
:skpefi

:: --- WINDOWS EI.CFG FILE ---
if not exist %SPAREVOL%\sources\ei.cfg goto :skipEI
echo.
echo WARNING: A \SOURCES\EI.CFG file exists
echo For Windows Vista and Windows 7 this can be deleted and you can then choose all OS versions.
echo For Windows 8\10, to get all versions, you need to edit it and perhaps add a PID.TXT file for the Product Key too?
echo see http://forums.mydigitallife.info/threads/45745-Delete-ei-cfg for more details
echo.
set ask=
set /p ask=Do you wish to delete the EI.CFG file (Y/[N]) : 
if /i "%ask%"=="Y" del %SPAREVOL%\Sources\EI.CFG & echo EI.CFG deleted
goto :skipEI8

:skipEI
if not exist %SPAREVOL%\sources\ei.cfg if  not exist %SPAREVOL%\sources\install.* goto :skipEI8
echo.
echo POSSIBLY WINDOWS 8\10 INSTALL FILES FOUND?
echo To get Win8/10 to prompt for all versions, 
echo choose V for the Volume Licensed version or R for the Retail version.
set ask=
set /p ask=Add Windows 8/10 EI.CFG file (V=Vol, R=Retail, [N]=No) : 
if /i "%ask%"=="V" copy .\Win8\EI_Vol.cfg %SPAREVOL%\Sources\EI.CFG > nul  & if errorlevel 1 color 4f & echo MAY NEED MORE SPACE? & pause & goto :unmount
if /i "%ask%"=="R" copy .\Win8\EI_Retail.cfg %SPAREVOL%\Sources\EI.CFG > nul  & if errorlevel 1 color 4f & echo MAY NEED MORE SPACE? & pause & goto :unmount

:skipEI8

:: --- COPY E2B FILES TO IMAGE ---
:: copy grldr and e2b folder
::copy .\csm\grldr %SPAREVOL%\ > nul  & if errorlevel 1 color 4f & echo MAY NEED MORE SPACE? & pause & goto :unmount
::xcopy /herky .\csm\e2b\*.* %SPAREVOL%\e2b\*.* > nul  & if errorlevel 1 color 4f & echo MAY NEED MORE SPACE? & pause & goto :unmount

:: ---- COPY csm folder
echo Copying .\csm folder...
:: copy all files except menu.lst from e2b folder 
xcopy /herky /EXCLUDE:.\Utils\EXCLUDE.lst .\csm\*.* %SPAREVOL%\*.* > nul  & if errorlevel 1 color 4f & echo MAY NEED MORE SPACE? & pause & goto :unmount

REM DO NOT CHANGE NEXT LINE! USED by Split_WinISO.exe to insert extra lines
:: ---- SET VOLUME LABEL ---
:: label the volume
label %SPAREVOL% %MYVOL%

REM Add bootmgr efi if Windows 7
echo.
if /i not "%PROCESSOR_ARCHITECTURE%"=="AMD64" goto :Fin7
if exist %SPAREVOL%\EFI\BOOT\BOOTX64.efi goto :Fin7
if exist %SPAREVOL%\bootmgr if exist %SPAREVOL%\bootmgr.efi if exist %SPAREVOL%\setup.exe if exist %SPAREVOL%\EFI\microsoft\boot\BCD goto :DO7
echo WARNING: No 64-bit EFI boot file \EFI\BOOT\BOOTX64.EFI found. & goto :Fin7
:DO7
if not exist %windir%\Boot\EFI\bootmgfw.efi echo WARNING: \EFI\BOOT\BOOTX64.EFI not found! & goto :Fin7
if not exist %SPAREVOL%\EFI\nul mkdir %SPAREVOL%\EFI
if not exist %SPAREVOL%\EFI\BOOT\nul mkdir %SPAREVOL%\EFI\BOOT
if exist %SPAREVOL%\EFI\BOOT\nul copy %windir%\Boot\EFI\bootmgfw.efi %SPAREVOL%\EFI\BOOT\BOOTX64.EFI > nul && echo INFORMATION: Windows bootmgfw.efi was copied to \EFI\BOOT\BOOTX64.EFI
:Fin7


:: ------ ISOLINUX\SYSLINUX UPDATE -----

:: remove syslinux.bin as it will contain the wrong ptn offset anyway
if exist %SPAREVOL%\syslinux.bin del %SPAREVOL%\syslinux.bin > nul

:: get version of syslinux into %SYSLV% - e.g. .\syslinux\syslinux4
:: List syslinux.cfg files
dir /s /b %SPAREVOL%\syslinux.cfg 2>NUL
dir /s /b %SPAREVOL%\isolinux.cfg 2>NUL
dir /s /b %SPAREVOL%\ldlinux.sys 2>NUL
call :SYSLV
if "%SYSLV%"=="N" goto :skpsysL
REM if "%NOISY%"=="" CLS

:: if already has syslinux folder, then use that for syslinux target
:: YUMI uses \multiboot
if exist %SPAREVOL%\multiboot\syslinux.cfg     set SYSDIR=%SPAREVOL%\MULTIBOOT&     set SYSDIRL=/multiboot&     goto :sysinst
if exist %SPAREVOL%\syslinux\syslinux.cfg      set SYSDIR=%SPAREVOL%\SYSLINUX&      set SYSDIRL=/syslinux&      goto :sysinst
if exist %SPAREVOL%\boot\syslinux\syslinux.cfg set SYSDIR=%SPAREVOL%\BOOT\SYSLINUX& set SYSDIRL=/boot/syslinux& goto :sysinst
if exist %SPAREVOL%\syslinux.cfg               set SYSDIR=%SPAREVOL%&               set SYSDIRL=/&              goto :sysinst
if exist %SPAREVOL%\slax\boot\syslinux.cfg     set SYSDIR=%SPAREVOL%\SLAX\BOOT&     set SYSDIRL=/slax/boot&     goto :sysinst
if exist %SPAREVOL%\slax\syslinux.cfg          set SYSDIR=%SPAREVOL%\SLAX&          set SYSDIRL=/slax&          goto :sysinst
if exist %SPAREVOL%\system\syslinux.cfg        set SYSDIR=%SPAREVOL%\SYSTEM&        set SYSDIRL=/system&        goto :sysinst
::if exist %SPAREVOL%\DLC1\Boot\syslinux.cfg     set SYSDIR=%SPAREVOL%\DLC1\Boot&     set SYSDIRL=/DLC1/Boot&     goto :sysinst

:: note some distros have a syslinux.cfg file in an isolinux folder!

set ISOLINDIR=%SPAREVOL%\isolinux
set SYSDIR=%SPAREVOL%\SYSLINUX
set SYSDIRL=/syslinux
if exist %ISOLINDIR%\isolinux.cfg goto :ISOLIN_CONV
if exist %ISOLINDIR%\syslinux.cfg goto :ISOLIN_CONV

set ISOLINDIR=%SPAREVOL%\boot\isolinux
set SYSDIR=%SPAREVOL%\boot\SYSLINUX
set SYSDIRL=/boot/syslinux
if exist %ISOLINDIR%\isolinux.cfg goto :ISOLIN_CONV
if exist %ISOLINDIR%\syslinux.cfg goto :ISOLIN_CONV

set ISOLINDIR=%SPAREVOL%
set SYSDIR=%SPAREVOL%
set SYSDIRL=/
if exist %ISOLINDIR%\isolinux.cfg goto :ISOLIN_CONV
if exist %ISOLINDIR%\syslinux.cfg goto :ISOLIN_CONV

set ISOLINDIR=%SPAREVOL%\system\isolinux
set SYSDIR=%SPAREVOL%\SYSTEM\SYSLINUX
set SYSDIRL=/system/syslinux
if exist %ISOLINDIR%\isolinux.cfg goto :ISOLIN_CONV
if exist %ISOLINDIR%\syslinux.cfg goto :ISOLIN_CONV

set ISOLINDIR=%SPAREVOL%\system
set SYSDIR=%SPAREVOL%\SYSTEM
set SYSDIRL=/system
if exist %ISOLINDIR%\isolinux.cfg goto :ISOLIN_CONV
if exist %ISOLINDIR%\syslinux.cfg goto :ISOLIN_CONV

set ISOLINDIR=%SPAREVOL%\slax\boot\isolinux
set SYSDIR=%SPAREVOL%\SLAX\BOOT\SYSLINUX
set SYSDIRL=/slax/boot/syslinux
if exist %ISOLINDIR%\isolinux.cfg goto :ISOLIN_CONV
if exist %ISOLINDIR%\syslinux.cfg goto :ISOLIN_CONV

set ISOLINDIR=%SPAREVOL%\slax
set SYSDIR=%SPAREVOL%\SLAX
set SYSDIRL=/slax
if exist %ISOLINDIR%\isolinux.cfg goto :ISOLIN_CONV
if exist %ISOLINDIR%\syslinux.cfg goto :ISOLIN_CONV

set ISOLINDIR=%SPAREVOL%\DLC1\BOOT
set SYSDIR=%SPAREVOL%\DLC1\BOOT
set SYSDIRL=/DLC1/BOOT
if exist %ISOLINDIR%\isolinux.cfg goto :ISOLIN_CONV
if exist %ISOLINDIR%\syslinux.cfg goto :ISOLIN_CONV


:: can't find syslinux\isolinux folder
echo WARNING: Failed to find a standard syslinux\isolinux boot folder in source payload. & pause & goto :skpsysL

:ISOLIN_CONV
if /i "%SYSDIR%"=="%ISOLINDIR%" goto :sysinst
:: Combine\Convert isolinux folder to syslinux folder
echo %ISOLINDIR% folder found - converting to %SYSDIR%...
if not exist %SYSDIR% move  %ISOLINDIR% %SYSDIR% > nul  & if errorlevel 1 color 4f & echo MOVE FAILED & pause & goto :unmount
:: copy files to syslinux folder only if they don't already exist
echo Copying over new files from %ISOLINDIR% to %SYSDIR%...
FOR /D %%F in ("%ISOLINDIR%") DO @(
   @ECHO N|COPY /-Y ^"%%~npdxF\*.*^" ^"%SYSDIR%^" 3>NUL 2>NUL >NUL
)
if exist %SYSDIR% if exist %ISOLINDIR% rd /s /q %ISOLINDIR% && echo %ISOLINDIR% deleted

:sysinst
:: SYSDIR has syslinux folder - e.g. U: or U:\syslinux
:: SYSDIRL has linux path with forward slash /
if "%MYFMT%"=="NTFS" echo WARNING: SYSLINUX\ISOLINUX files found - but cannot install boot code using syslinux.exe on an NTFS volume. & pause & goto :skpsysL
echo.
if "%SYSDIR%"=="" goto :skpsysL
if not exist %SYSDIR%\syslinux.cfg if exist %SYSDIR%\isolinux.cfg ren %SYSDIR%\isolinux.cfg syslinux.cfg > nul
echo INSTALLING SYSLINUX TO %SYSDIR% (using %SYSLV%)...
echo.
attrib -r -h -s %SYSDIR%\*.*
if exist %SYSDIR%\ldlinux.sys del %SYSDIR%\ldlinux.sys
if not exist %SYSDIR%\syslinux.cfg echo WARNING: No %SYSDIR%\syslinux.cfg file found! & pause
:: if syslinux 5 or 6 should add ldlinux.sys and ldlinux.c32
set SS=%SYSLV%\syslinux.exe
if /i "%PROCESSOR_ARCHITECTURE%"=="AMD64" if exist %SYSLV%\syslinux64.exe set SS=%SYSLV%\syslinux64.exe
%SS% -f -d %SYSDIRL% %SPAREVOL% %SPAREVOL%\syslinux.bin  & if errorlevel 1 pause & goto :unmount
::unhide the two files so we can see them!
attrib -r -h -s %SYSDIR%\*.*

if not exist %SYSDIR%\ldlinux.sys echo ERROR: %SYSDIR%\ldlinux.sys was not created! & pause

:sysUpd

:: -- UPDATE SYSLINUX FILES FROM %SYSDIR% folder ---
:: Add correct version of vesamenu.c32, chain.32 and menu.c32
echo Updating vesamenu.c32, chain.c32 and menu.c32 in %SYSDIR% (using %SYSLV%)
if exist %SYSDIR%\vesamenu.c32 copy %SYSLV%\vesamenu.c32 %SYSDIR%\vesamenu.c32 > nul & echo Updated %SYSDIR%\vesamenu.c32
:: if DLC1 then keep menu.c32
if not exist %SPAREVOL%\DLC1\Boot\menu.c32 if exist %SYSDIR%\menu.c32     copy %SYSLV%\menu.c32     %SYSDIR%\menu.c32 > nul     & echo Updated %SYSDIR%\menu.c32
if exist %SYSDIR%\chain.c32    copy %SYSLV%\chain.c32    %SYSDIR%\chain.c32 > nul    & echo Updated %SYSDIR%\chain.c32
:: for syslinux 5/6 always update ldlinux.c32
REM if exist %SYSDIR%\ldlinux.c32 attrib -r -h -s %SYSDIR%\ldlinux.c32 > nul
if exist %SYSLV%\ldlinux.c32   copy %SYSLV%\ldlinux.c32   %SYSDIR%\ldlinux.c32 > nul  & echo Updated %SYSDIR%\ldlinux.c32
if exist %SYSLV%\libcom32.c32  copy %SYSLV%\libcom32.c32  %SYSDIR%\libcom32.c32 > nul & echo Updated %SYSDIR%\libcom32.c32
if exist %SYSLV%\libutil.c32   copy %SYSLV%\libutil.c32   %SYSDIR%\libutil.c32 > nul  & echo Updated %SYSDIR%\libutil.c32

REM older versions of syslinux may require syslinux.cfg in root or some standard location
if "%SYSLV%"==".\syslinux\syslinux_386" if not exist %SPAREVOL%\syslinux.cfg copy %SYSDIR%\syslinux.cfg %SPAREVOL%\syslinux.cfg > nul & echo syslinux.cfg also copied to \
if "%SYSLV%"==".\syslinux\syslinux_375" if not exist %SPAREVOL%\syslinux.cfg copy %SYSDIR%\syslinux.cfg %SPAREVOL%\syslinux.cfg > nul & echo syslinux.cfg also copied to \

REM fixup for DLC
if exist %SPAREVOL%\syslinux.bin if exist %SPAREVOL%\DLC1\Boot\syslinux.cfg copy %SPAREVOL%\syslinux.bin %SPAREVOL%\DLC1\Boot\syslinux.bin > nul
if exist %SPAREVOL%\syslinux.bin if exist %SPAREVOL%\DLCD\Boot\syslinux.cfg copy %SPAREVOL%\syslinux.bin %SPAREVOL%\DLCD\Boot\syslinux.bin > nul

REM delay for user to see
PING -n 5 127.0.0.1>nul
 
:skpsysL
:: ----------- END OF SYSLINUX UPDATE -----

:: restore build file for Dell dtk
if exist %SPAREVOL%\syslinux\BUILD xcopy /herky %SPAREVOL%\syslinux\BUILD %SPAREVOL%\isolinux\

::pause
::@echo off

:: ------- ADD REFIND FILES ----
if exist .\REFIND\REFIND.cmd if "%DOREFIND%"=="1" call .\REFIND\REFIND.cmd

:: --- MENU.LST UPDATE ---

::open explorer window (loses focus and user must close or cannot dismount!)
if exist %SPAREVOL%\menu.lst if "%NOEXPLORER%"=="" explorer %SPAREVOL%\

:menust
if not exist %SPAREVOL%\menu.lst if exist .\CUSTOM\menu.lst copy .\CUSTOM\menu.lst %SPAREVOL%\ > nul & echo CUSTOM\MENU.LST used & goto :skpmen0
if not exist %SPAREVOL%\menu.lst copy .\csm\menu.lst %SPAREVOL%\ > nul & goto :skpmen0

echo.
echo --------- MENU.LST FOUND -------------
echo.
echo WARNING: a MENU.LST file already exists in the IMAGE at %SPAREVOL%\
echo If you don't replace it, you must add the contents of .\csm\menu.lst to the one on %SPAREVOL%\menu.lst
echo.
echo  N = Do not change. You may need to edit the %SPAREVOL%\menu.lst file and add in the contents from %~dp0menu.lst
echo  R = Replaces the menu.lst with the E2B's menu.lst (e.g. use for KonBoot/Hirens)
echo  Y = Combines the two menu.lst files (you can edit it later)
echo.
set ask=
set /p ask=OK to COMBINE MENU.LST files ([Y]/R/N) : 
if /i "%ask%"=="R" goto :skpmenr
if /i not "%ask%"=="N" goto :skpmenc

:: --- KEEP ORIGINAL MENU ---
echo WARNING: You will not be able to restore the E2B drive unless you edit the menu.lst!
echo You must add the contents of .\csm\menu.lst to the one on %SPAREVOL%\menu.lst.
echo.
set ask=
set /p ask=ARE YOU SURE YOU WANT TO KEEP THE ORIGINAL MENU.LST FILE (Y/[N]) : 
if /i "%ask%"=="Y" goto :skpmen0
goto :menust

:skpmenc
:: --- COMBINE MENU.LST files ---
copy .\csm\menu.lst+%SPAREVOL%\menu.lst xxyyzz.lst > nul
if exist .\CUSTOM\menu.lst copy .\CUSTOM\menu.lst+%SPAREVOL%\menu.lst xxyyzz.lst > nul
copy xxyyzz.lst %SPAREVOL%\menu.lst > nul
del xxyyzz.lst > nul
echo.
if exist .\CUSTOM\menu.lst     echo CUSTOM MENU.LST + ORIGINAL HAVE BEEN COMBINED!
if not exist .\CUSTOM\menu.lst echo MENU.LST + ORIGINAL HAVE BEEN COMBINED!
echo You can edit %SPAREVOL%\MENU.LST before dismounting the volume
goto :skpmen0

:skpmenr
:: --- REPLACE WITH E2B menu.lst ---
if /i not "%ask%"=="R" goto :skpmen0
copy .\csm\menu.lst  %SPAREVOL%\menu.lst > nul
if exist .\CUSTOM\menu.lst copy .\CUSTOM\menu.lst  %SPAREVOL%\menu.lst > nul
if exist .\CUSTOM\menu.lst     echo ORIGINAL MENU.LST REPLACED WITH CUSTOM MENU.LST
if not exist .\CUSTOM\menu.lst echo ORIGINAL MENU.LST REPLACED WITH CSM MENU.LST
:skpmen0


:: --- SET PAYLOAD NAME AS TITLE IN MENU By REPLACING 'PAYLOAD=' ---
:: if extracted from file then use that as filename - otherwise we would need to prompt
:: if it was a file the ISOSZ will be a big number
if not %ISOSZ% GEQ 2 goto :skptfldr
:: It was a file, so get name
call :getname !MYSOURCE!
set REPSTRING=%NM%
goto :fixname

:skptfldr
:: we have no name as the SOURCE was a folder - use command line param if present
set REPSTRING=%MYTITLE%
:: if user entered all 5 parameters, then use 6th as title, if no 6th param then no title will be set
if not "%~5"=="" goto :fixname
:: if 5th param (MYVOL) was not specified then prompt user for MYTITLE
echo.
if not "%AUTORUN%"=="Y" set /p REPSTRING=Enter a name for the title of the CSM menu : 
if "%REPSTRING%"=="" set REPSTRING=EASY2BOOT PARTITION IMAGE

:fixname
:: Change PAYLOAD= into title name in file
.\utils\ssed "s/##set PAYLOAD= ;;/set PAYLOAD=%REPSTRING% ;; /" %SPAREVOL%\menu.lst > %SPAREVOL%\menu.MPI
if exist %SPAREVOL%\menu.lst del %SPAREVOL%\menu.lst & ren  %SPAREVOL%\menu.MPI menu.lst
if not "%REPSTRING%"=="" echo. & echo TITLE WILL BE %REPSTRING%
if not exist %SPAREVOL%\heading.g4b (
echo ^^!BAT > %SPAREVOL%\heading.g4b
echo set PAYLOAD=%REPSTRING% >> %SPAREVOL%\heading.g4b
)


:: --- CREATE AUTORUN.INF FILE ---

if not "%REPSTRING%"=="" goto :fixauto
::if not %ISOSZ% GEQ 2 goto :skpauto
::call :getname !MYSOURCE!
::set REPSTRING=%NM%
:fixauto
:: add autorun.inf file for full name display in Explorer
echo ; Created using MakePartImage for Easy2Boot > %SPAREVOL%\autorun.inf
echo ; http://www.easy2boot.com >> %SPAREVOL%\autorun.inf
echo [autorun] >> %SPAREVOL%\autorun.inf
echo label = %REPSTRING% >> %SPAREVOL%\autorun.inf
if exist .\csm\autorun.ico copy .\csm\autorun.ico %SPAREVOL%\ > nul
if exist .\csm\autorun.ico echo icon = autorun.ico >> %SPAREVOL%\autorun.inf
:skpauto

::copy all files from CLOVER folder
if "%NOCLOVER%"=="1" goto :skpclov1
if exist .\CLOVER\csm\nul xcopy /herky .\CLOVER\CSM\*.* %SPAREVOL%\*.* > nul & if errorlevel 1 echo ERROR COPYING CLOVER\CSM FOLDER (maybe not enough space?) & if errorlevel 1 pause & goto :unmount
if exist .\CLOVER\csm\nul echo. & echo INFORMATION: CLOVER UEFI BOOT LOADER has been added to the CSM menu.
:skpclov1

::copy all files except menu.lst from CUSTOM folder
if exist .\CUSTOM\nul xcopy /herky /EXCLUDE:.\Utils\EXCLUDE.lst .\CUSTOM\*.* %SPAREVOL%\*.* > nul & if errorlevel 1 echo ERROR COPYING CUSTOM FOLDER (maybe not enough space?) & if errorlevel 1 pause & goto :unmount
if exist .\CUSTOM\nul echo. & echo INFORMATION: All files in CUSTOM Folder have been copied.



TITLE %MPV% - IMAGE !MYSOURCE! MOUNTED AS %SPAREVOL%
REM echo.
REM echo IMAGE CONTENTS ON %SPAREVOL%
REM echo ====================
REM echo.
REM vdir /b %SPAREVOL%\
REM echo.
echo.
if not "%AUTORUN%"=="Y" if not exist %SPAREVOL%\EFI\boot\nul echo INFORMATION: No \EFI\boot folder found.
if not "%AUTORUN%"=="Y" if     exist %SPAREVOL%\EFI\boot\nul echo INFORMATION: \EFI\boot folder found - so may support UEFI booting.
if not "%AUTORUN%"=="Y" echo.
if not "%AUTORUN%"=="Y" echo You can inspect the %SPAREVOL% volume in Explorer now if you wish.
if not "%AUTORUN%"=="Y" echo You can edit the \menu.lst file if you wish.
echo VOLUME LABEL = %MYVOL% 
::   you can change the Volume Label using Windows Explorer-Properties now if you wish.
if not "%AUTORUN%"=="Y" echo.
if not "%AUTORUN%"=="Y" echo.
if not "%AUTORUN%"=="Y" echo YOU CAN NOW CHANGE THE CONTENTS OF THE NEW IMAGE MOUNTED ON VOLUME %SPAREVOL%
if not "%AUTORUN%"=="Y" echo.
if not "%AUTORUN%"=="Y" echo Press a key to dismount %SPAREVOL% and write it to !MYIMG!...
if not "%AUTORUN%"=="Y" echo. & pause
set DONE=Y

TITLE %MPV% - %~n0 !MYSOURCE!
echo.

:: WE NEED TO GET CURRENT VOLUME LABEL that works in all languages on imdisk
call :getvol %SPAREVOL%

:: --- ADJUST FILES IN IMAGE ---
if exist %SPAREVOL%\LiveOS\overlay-* ren %SPAREVOL%\LiveOS\overlay-* overlay-%MYVOL%-%UUID% & echo INFORMATION: Overlay file was renamed to overlay-%MYVOL%-%UUID%

:: --------- CHECK FOR LABEL and UUIDs -----------
:: check .cfg, .conf and .lst files for (CD)LABEL= =UUID= :UUID= and <>media=  (set FART and CONF, LST and CFG variables if found)
REM if "%NOISY%"=="" CLS
call :chklabels
if  not "%FART%"=="1" goto :skpcfg

echo.
echo UUID          should use %UUID%
echo CDLABEL       should be  LABEL
echo LABEL         should use %MYVOL%
echo 'media=cdrom' should be 'media=usb'
echo.

set CDEF=Y
if exist %SPAREVOL%\MEDICAT\nul set CDEF=N
if exist %SPAREVOL%\Programs\nul set CDEF=N
if exist %SPAREVOL%\DLC1\nul set CDEF=N
if exist %SPAREVOL%\DLCD\nul set CDEF=N
if exist %SPAREVOL%\HBCD\nul set CDEF=N
if exist %SPAREVOL%\DLC\nul set CDEF=N
if exist %SPAREVOL%\cdusb.y set CDEF=N
if exist %SPAREVOL%\boot\grub\grub.cfg.sig set CDEF=N & echo WARNING: .cfg files are signed and may not UEFI-boot if they are changed. & echo.
::if "%NOCONV%"=="1" if "%AUTORUN%"=="Y" goto :skpcfg
set ask=
if not "%AUTORUN%"=="Y"  set Del=30
if "%AUTORUN%"=="Y" set Del=10
echo Note: If the source files are designed to be run from a USB drive (e.g. Medicat, Bob Omb's WinPE, DLC, etc.)
echo it may be better to not auto-correct the configuration files.
echo.
echo Timeout in %Del% seconds       (default=%CDEF%)...
choice /c YN /N /D %CDEF% /T %Del% /M "AUTO-CORRECT? (Y/N) : "
if errorlevel 2 goto :skpcfg
echo.
echo AUTO-CORRECTING menu files...
echo Changing parameters for use with USB drive - please wait...
if exist .\UTILS\LREPLACE.LOG del .\UTILS\LREPLACE.LOG
REM set "Q=>> mpi.log 2>&1" & if exist mpi.log del mpi.log

echo Checking *.conf files...
if "%CONF%"=="1" for /R %SPAREVOL%\ %%i in (*.conf) DO echo %%i >> LIST.txt
if exist LIST.txt for /f %%i in (LIST.TXT) DO call .\UTILS\LREPLACE.cmd %%i %UUID% %MYVOL% %Q%
if exist LIST.txt del LIST.txt

echo Checking *.cfg files...
if "%CFG%"=="1"  for /R %SPAREVOL%\ %%i in (*.cfg)  DO echo %%i >> LIST.txt
if exist LIST.txt for /f %%i in (LIST.TXT) DO call .\UTILS\LREPLACE.cmd %%i %UUID% %MYVOL% %Q%
if exist LIST.txt del LIST.txt

echo Checking *.lst files...
if "%LST%"=="1"  for /R %SPAREVOL%\ %%i in (*.lst)  DO echo %%i >> LIST.txt
if exist LIST.txt for /f %%i in (LIST.TXT) DO call .\UTILS\LREPLACE.cmd %%i %UUID% %MYVOL% %Q%
if exist LIST.txt del LIST.txt

echo.
echo. %QUIET%
echo NEW LABEL, MEDIA and UUID lines %QUIET%
echo =============================== %QUIET%
call :chklabels  %QUIET%
:skpcfg
echo.
if exist .\UTILS\LREPLACE.LOG del  .\UTILS\LREPLACE.LOG

:: ------ END OF CHECK LABELS --------



:: -- FINAL CHECK FOR CORRECT MENU.LST FILE ----

.\UTILS\fart.exe -i -r -p %SPAREVOL%\menu.lst "dd if=(hd0)" > fart.log 2>nul
if errorlevel 1 goto :skpmc
echo.
echo ERROR: %SPAREVOL%\menu.lst does not contain any code to restore the E2B partitions!
set DONE=
pause
:skpmc



:: ----------- DISMOUNT IMAGE --------
:unmount
TITLE %MPV% - %~n0 !MYSOURCE!
:: Display free space

echo PARTITION IMAGE SPACE USAGE
echo ===========================

::WMIC.EXE LogicalDisk Where DeviceID="%SPAREVOL%" Get DeviceID,FileSystem,FreeSpace 

for /f "tokens=4 delims= " %%a in ('.\utils\df.exe %SPAREVOL% -b') do set UNUSED=%%a
set /a UNUSED=%UNUSED%/1000
for /f "tokens=3 delims= " %%a in ('.\utils\df.exe %SPAREVOL% -b') do set USED=%%a
set /a USED=%USED%/1000
echo USED=%USED%MB     UNUSED=%UNUSED%MB
echo.

:: tidy up
if exist fart.log del fart.log
if exist myvol.log del myvol.log
if exist imdisk.log del imdisk.log
echo Dismounting %SPAREVOL%...
PING -n 3 127.0.0.1>nul
IMDISK.EXE -d -m %SPAREVOL% >nul 2>&1
if errorlevel 1 PING -n 3 127.0.0.1>nul & IMDISK.EXE -d -m %SPAREVOL% >nul 2>&1
REM if errorlevel 1 echo WARNING: Cannot dismount volume %SPAREVOL% - Please close all open files and all Explorer windows on %SPAREVOL% & if not "%AUTORUN%"=="Y" pause
PING -n 3 127.0.0.1>nul
if errorlevel 1 IMDISK.EXE -d -m %SPAREVOL% >nul 2>&1
REM force closure
if exist %SPAREVOL%\nul IMDISK.EXE -D -m %SPAREVOL% >nul 2>&1
REM if errorlevel 1 echo Forcing Volume to dismount & IMDISK.EXE -D -m %SPAREVOL% >nul 2>&1 & if errorlevel 1 echo WARNING: IMAGE MAY BE CORRUPT! & start imdisk.cpl
if exist %SPAREVOL%\nul echo ERROR: IMAGE WAS NOT DISMOUNTED!
if exist %SPAREVOL%\nul echo        USE CONTROL PANEL - IMDISK to 'Remove' the  virtual drive %SPAREVOL% & start imdisk.cpl & color 4f & pause
echo.
if     "%DONE%"=="Y" if exist !MYIMG! echo !MYIMG! created OK.
if not "%DONE%"=="Y" echo ERROR: Something went wrong! & echo Try a larger size? & if "%MYFMT%"=="FAT32" echo Use NTFS if there are files larger than 4GB.

:: open Explorer to show user the image file
call :getpath !MYIMG!

if "%DONE%"=="Y" if "%NOEXPLORER%"=="" explorer !PP!
if not "%DONE%"=="Y" color 4f & if exist !MYIMG! del !MYIMG!
echo.
REM if not "%DONE%"=="Y" echo Tip: Try using a .imgPTNLBAa file extension if some systems won't boot correctly.


ENDLOCAL
goto :eof

:: ---------------------------  END ------------------------



:: --- SUBROUTINES ---

:getsz
:: try getting uncompressed size using 7z
Echo Getting size of "%~1" - please wait...
if exist t.txt del t.txt
if exist t1.txt del t1.txt
.\7z\7z.exe t "%~1" > t.txt
if errorlevel 1 set SZ=%~z1&& goto :EOF
if exist t.txt find "Size:" t.txt > t1.txt
set SZ=
if not exist t1.txt set SZ=%~z1&& goto :EOF
FOR /F "delims=:  tokens=2" %%i IN (t1.txt) DO set SZ=%%i
REM remove spaces
REM If no good, use file size
if "%SZ%"=="" set SZ=%~z1&& goto :EOF
:SPr
if "%SZ:~0,1%"==" " set SZ=%SZ:~1,199%&& goto :SPr
if "%SZ%"=="" set SZ=%~z1&& goto :EOF
if "%SZ%"=="0" set SZ=%~z1&& goto :EOF
echo Size %~x1                : %~z1
echo Size %~x1 (decompressed) : %SZ%

REM get number of files
find "Files:" t.txt> t1.txt
FOR /F "delims=:  tokens=2" %%i IN (t1.txt) DO set SZF=%%i
REM remove spaces
:SPrf
if "%SZF%"=="" goto :EOF
if "%SZF:~0,1%"==" " set SZF=%SZF:~1,199%&& goto :SPrf
echo Files in %~x1            : %SZF%
if "%SZF%"=="" goto :EOF
if "%SZF%"=="0" goto :EOF
REM assume 4K clusters (can be 8K if 8GB+ file)  (*4 fails on some large 4GB files, so use *6)
REM Must work in K so not to exceed maths 32-bit limit
set SZF=%SZF%*6
set SZ=%SZ:~0,-3%
set /a SZ=%SZ%+%SZF%+1
set SZ=%SZ%000
set SZF=
if exist t.txt del t.txt
if exist t1.txt del t1.txt
goto :eof

:check_Permissions
    net session >nul 2>&1
    if not errorLevel 1 (
        echo Administrative permissions confirmed.
    ) else (
        echo Sorry - you need to run as Administrator [use right-click - Run as administrator].
		echo.
		echo Tip: Make a shortcut and change the Properties to Admin
		echo      Then you can drag-and-drop an ISO or folder onto the shortcut icon.
		echo.
	color cf
	pause
	Set ADMIN=FAIL
    )
goto :eof

:checkperms
set randname=%random%%random%%random%%random%%random%
md "%windir%\%randname%" 2>nul
if %errorlevel%==0 (echo Administrative permissions confirmed.
goto end)
if %errorlevel%==1 (
    echo Sorry - you need to run as Administrator [use right-click - Run as administrator].
	echo.
	color cf
	pause
	Set ADMIN=FAIL
	goto end)
goto checkperms
:end
rd "%windir%\%randname%" 2>nul
goto :eof


:: ---

:getpath
set "PP=%~dp1"
goto :eof

:: ---

:getfname
set "FN=%~dpn1"
goto :eof

:: ---

:getname
set "NM=%~n1"
goto :eof

:: ---

:getfp
:: always put full path in quotes
set "FP=%~f1"
if not ^%FP:~0,1%==^" set FP="!FP!"
goto :eof

:: ---

:getext
set EXT=%~x1
goto :eof

:: ---   FIXUPS -  CHECK FOR linux parameters - e.g. UUID, CDLABEL, LABEL and media ---

:chklabels
set FART=
::if exist %SPAREVOL%\ntldr goto :eof
::if exist %SPAREVOL%\i386\* goto :eof
::if exist %SPAREVOL%\io.sys goto :eof

:: dont bother if Win install payload
if exist %SPAREVOL%\sources\install.* goto :eof
echo.

.\UTILS\fart.exe -i -r -p %SPAREVOL%\*.conf "isolinux" > fart.log 2>nul
if errorlevel 1 echo INFORMATION: 'isolinux' occurs in .CONF files & type fart.log %QUIET%&  set FART=1& set CONF=1& if "%QUIET%"=="" pause
.\UTILS\fart.exe -i -r -p %SPAREVOL%\*.cfg "isolinux" > fart.log 2>nul
if errorlevel 1 echo INFORMATION: 'isolinux' occurs in .CFG files & type fart.log %QUIET%&  set FART=1& set CFG=1& if "%QUIET%"=="" pause
.\UTILS\fart.exe -i -r -p %SPAREVOL%\*.lst "isolinux" > fart.log 2>nul
if errorlevel 1 echo INFORMATION: 'isolinux' occurs in .LST files & type fart.log %QUIET%&  set FART=1& set LST=1& if "%QUIET%"=="" pause

.\UTILS\fart.exe -i -r -p %SPAREVOL%\*.conf "UUID=" > fart.log 2>nul
if errorlevel 1 echo INFORMATION: UUID occurs in .CONF files & type fart.log %QUIET%&   set FART=1& set CONF=1& if "%QUIET%"=="" pause
.\UTILS\fart.exe -i -r -p %SPAREVOL%\*.cfg "UUID=" > fart.log 2>nul
if errorlevel 1 echo INFORMATION: UUID occurs in .CFG files & type fart.log %QUIET%&  set FART=1& set CFG=1& if "%QUIET%"=="" pause
.\UTILS\fart.exe -i -r -p %SPAREVOL%\*.lst "UUID=" > fart.log 2>nul
if errorlevel 1 echo INFORMATION: UUID occurs in .LST files & type fart.log %QUIET%&  set FART=1& set LST=1& if "%QUIET%"=="" pause

::.\UTILS\fart.exe -i -r -p %SPAREVOL%\*.conf ":UUID=" > fart.log 2>nul
::if errorlevel 1 echo INFORMATION: UUID occurs in .CONF files & type fart.log %QUIET%&  set FART=1& set CONF=1& if "%QUIET%"=="" pause
::.\UTILS\fart.exe -i -r -p %SPAREVOL%\*.cfg ":UUID=" > fart.log 2>nul
::if errorlevel 1 echo INFORMATION: UUID occurs in .CFG files & type fart.log %QUIET%&  set FART=1& set CFG=1& if "%QUIET%"=="" pause
::.\UTILS\fart.exe -i -r -p %SPAREVOL%\*.lst ":UUID=" > fart.log 2>nul
::if errorlevel 1 echo INFORMATION: UUID occurs in .LST files & type fart.log %QUIET%&  set FART=1& set LST=1& if "%QUIET%"=="" pause

.\UTILS\fart.exe -i -r -p %SPAREVOL%\*.conf "LABEL=" > fart.log 2>nul
if errorlevel 1 echo INFORMATION: LABEL occurs in .CONF files & type fart.log %QUIET%&  set FART=1& set CONF=1& if "%QUIET%"=="" pause
.\UTILS\fart.exe -i -r -p %SPAREVOL%\*.cfg "LABEL=" > fart.log 2>nul
if errorlevel 1 echo INFORMATION: LABEL occurs in .CFG files & type fart.log %QUIET%&  set FART=1& set CFG=1& if "%QUIET%"=="" pause
.\UTILS\fart.exe -i -r -p %SPAREVOL%\*.lst "LABEL=" > fart.log 2>nul
if errorlevel 1 echo INFORMATION: LABEL occurs in .LST files & type fart.log %QUIET%&  set FART=1& set LST=1& if "%QUIET%"=="" pause

.\UTILS\fart.exe -i -r -p %SPAREVOL%\*.conf "media=" > fart.log 2>nul
if errorlevel 1 echo INFORMATION: 'media=' occurs in .CONF files & type fart.log %QUIET%&  set FART=1& set CONF=1& if "%QUIET%"=="" pause
.\UTILS\fart.exe -i -r -p %SPAREVOL%\*.cfg "media=" > fart.log 2>nul
if errorlevel 1 echo INFORMATION: 'media=' occurs in .CFG files & type fart.log %QUIET%&  set FART=1& set CFG=1& if "%QUIET%"=="" pause
.\UTILS\fart.exe -i -r -p %SPAREVOL%\*.lst "media=" > fart.log 2>nul
if errorlevel 1 echo INFORMATION: 'media=' occurs in .LST files & type fart.log %QUIET%&  set FART=1& set LST=1& if "%QUIET%"=="" pause

.\UTILS\fart.exe -i -r -p %SPAREVOL%\*.conf "COM32" > fart.log 2>nul
if errorlevel 1 echo INFORMATION: 'COM32' occurs in .CONF files & type fart.log %QUIET%&  set FART=1& set CONF=1& if "%QUIET%"=="" pause
.\UTILS\fart.exe -i -r -p %SPAREVOL%\*.cfg "COM32" > fart.log 2>nul
if errorlevel 1 echo INFORMATION: 'COM32' occurs in .CFG files & type fart.log %QUIET%&  set FART=1& set CFG=1& if "%QUIET%"=="" pause
.\UTILS\fart.exe -i -r -p %SPAREVOL%\*.lst "COM32" > fart.log 2>nul
if errorlevel 1 echo INFORMATION: 'COM32' occurs in .LST files & type fart.log %QUIET%&  set FART=1& set LST=1& if "%QUIET%"=="" pause

.\UTILS\fart.exe -i -r -p %SPAREVOL%\*.conf "APPEND" > fart.log 2>nul
if errorlevel 1 echo INFORMATION: 'APPEND' occurs in .CONF files & type fart.log %QUIET%&  set FART=1& set CONF=1& if "%QUIET%"=="" pause
.\UTILS\fart.exe -i -r -p %SPAREVOL%\*.cfg "APPEND" > fart.log 2>nul
if errorlevel 1 echo INFORMATION: 'APPEND' occurs in .CFG files & type fart.log %QUIET%&  set FART=1& set CFG=1& if "%QUIET%"=="" pause
.\UTILS\fart.exe -i -r -p %SPAREVOL%\*.lst "APPEND" > fart.log 2>nul
if errorlevel 1 echo INFORMATION: 'APPEND' occurs in .LST files & type fart.log %QUIET%&  set FART=1& set LST=1& if "%QUIET%"=="" pause



::AOSS
.\UTILS\fart.exe -i -r -p %SPAREVOL%\*.conf "boot=" > fart.log 2>nul
if errorlevel 1 echo INFORMATION: 'boot=' occurs in .CONF files & type fart.log %QUIET%&  set FART=1& set CONF=1& if "%QUIET%"=="" pause
.\UTILS\fart.exe -i -r -p %SPAREVOL%\*.cfg "boot=" > fart.log 2>nul
if errorlevel 1 echo INFORMATION: 'boot=' occurs in .CFG files & type fart.log %QUIET%&  set FART=1& set CFG=1& if "%QUIET%"=="" pause
.\UTILS\fart.exe -i -r -p %SPAREVOL%\*.lst "boot=" > fart.log 2>nul
if errorlevel 1 echo INFORMATION: 'boot=' occurs in .LST files & type fart.log %QUIET%&  set FART=1& set LST=1& if "%QUIET%"=="" pause

::Porteus
.\UTILS\fart.exe -i -r -p %SPAREVOL%\*.conf "changes=" > fart.log 2>nul
if errorlevel 1 echo INFORMATION: 'changes=' occurs in .CONF files & type fart.log %QUIET%&  set FART=1& set CONF=1& if "%QUIET%"=="" pause
.\UTILS\fart.exe -i -r -p %SPAREVOL%\*.cfg "changes=" > fart.log 2>nul
if errorlevel 1 echo INFORMATION: 'changes=' occurs in .CFG files & type fart.log %QUIET%&  set FART=1& set CFG=1& if "%QUIET%"=="" pause
.\UTILS\fart.exe -i -r -p %SPAREVOL%\*.lst "changes=" > fart.log 2>nul
if errorlevel 1 echo INFORMATION: 'changes=' occurs in .LST files & type fart.log %QUIET%&  set FART=1& set LST=1& if "%QUIET%"=="" pause


:: PCLinuxOS
::.\UTILS\fart.exe -i -r -p %SPAREVOL%\*.conf "livecd=livecd" > fart.log 2>nul
::if errorlevel 1 echo INFORMATION: 'livecd=livecd' occurs in .CONF files & type fart.log %QUIET%&  set FART=1& set CONF=1& if "%QUIET%"=="" pause
.\UTILS\fart.exe -i -r -p %SPAREVOL%\*.cfg "livecd=livecd" > fart.log 2>nul
if errorlevel 1 echo INFORMATION: 'livecd=livecd' occurs in .CFG files & type fart.log %QUIET%&  set FART=1& set CFG=1& if "%QUIET%"=="" pause
.\UTILS\fart.exe -i -r -p %SPAREVOL%\*.lst "livecd=livecd" > fart.log 2>nul
if errorlevel 1 echo INFORMATION: 'livecd=livecd' occurs in .LST files & type fart.log %QUIET%&  set FART=1& set LST=1& if "%QUIET%"=="" pause


:: GRML
::.\UTILS\fart.exe -i -r -p %SPAREVOL%\*.conf "bootid=" > fart.log 2>nul
::if errorlevel 1 echo INFORMATION: 'bootid=' occurs in .CONF files & type fart.log %QUIET%&  set FART=1& set CONF=1& if "%QUIET%"=="" pause
.\UTILS\fart.exe -i -r -p %SPAREVOL%\*.cfg "bootid=" > fart.log 2>nul
if errorlevel 1 echo INFORMATION: 'bootid=' occurs in .CFG files & type fart.log %QUIET%&  set FART=1& set CFG=1& if "%QUIET%"=="" pause
.\UTILS\fart.exe -i -r -p %SPAREVOL%\*.lst "bootid=" > fart.log 2>nul
if errorlevel 1 echo INFORMATION: 'bootid=' occurs in .LST files & type fart.log %QUIET%&  set FART=1& set LST=1& if "%QUIET%"=="" pause


::Trinity Rescue
::.\UTILS\fart.exe -i -r -p %SPAREVOL%\*.conf "initrd=initrd.trk r" > fart.log 2>nul
::if errorlevel 1 echo INFORMATION: 'initrd=initrd.trk r' occurs in .CONF files & type fart.log %QUIET%&  set FART=1& set CONF=1& if "%QUIET%"=="" pause
.\UTILS\fart.exe -i -r -p %SPAREVOL%\*.cfg "initrd=initrd.trk r" > fart.log 2>nul
if errorlevel 1 echo INFORMATION: 'initrd=initrd.trk r' occurs in .CFG files & type fart.log %QUIET%&  set FART=1& set CFG=1& if "%QUIET%"=="" pause
.\UTILS\fart.exe -i -r -p %SPAREVOL%\*.lst "initrd=initrd.trk r" > fart.log 2>nul
if errorlevel 1 echo INFORMATION: 'initrd=initrd.trk r' occurs in .LST files & type fart.log %QUIET%&  set FART=1& set LST=1& if "%QUIET%"=="" pause


::Liberte
::.\UTILS\fart.exe -i -r -p %SPAREVOL%\*.conf "cdroot_hash=" > fart.log 2>nul
::if errorlevel 1 echo INFORMATION: 'cdroot_hash=' occurs in .CONF files & type fart.log %QUIET%&  set FART=1& set CONF=1& if "%QUIET%"=="" pause
.\UTILS\fart.exe -i -r -p %SPAREVOL%\*.cfg "cdroot_hash=" > fart.log 2>nul
if errorlevel 1 echo INFORMATION: 'cdroot_hash=' occurs in .CFG files & type fart.log %QUIET%&  set FART=1& set CFG=1& if "%QUIET%"=="" pause
.\UTILS\fart.exe -i -r -p %SPAREVOL%\*.lst "cdroot_hash=" > fart.log 2>nul
if errorlevel 1 echo INFORMATION: 'cdroot_hash=' occurs in .LST files & type fart.log %QUIET%&  set FART=1& set LST=1& if "%QUIET%"=="" pause


::gfxboot UBUNTU
::.\UTILS\fart.exe -i -r -p %SPAREVOL%\*.conf "ui gfxboot" > fart.log 2>nul
::if errorlevel 1 echo INFORMATION: 'ui gfxboot' occurs in .CONF files & type fart.log %QUIET%&  set FART=1& set CONF=1& if "%QUIET%"=="" pause
.\UTILS\fart.exe -i -r -p %SPAREVOL%\*.cfg "ui gfxboot" > fart.log 2>nul
if errorlevel 1 echo INFORMATION: 'ui gfxboot' occurs in .CFG files & type fart.log %QUIET%&  set FART=1& set CFG=1& if "%QUIET%"=="" pause
.\UTILS\fart.exe -i -r -p %SPAREVOL%\*.lst "ui gfxboot" > fart.log 2>nul
if errorlevel 1 echo INFORMATION: 'ui gfxboot' occurs in .LST files & type fart.log %QUIET%&  set FART=1& set LST=1& if "%QUIET%"=="" pause

::paldo img files have .conf
.\UTILS\fart.exe -i -r -p %SPAREVOL%\*.conf "root=" > fart.log 2>nul
if errorlevel 1 echo INFORMATION: 'root=' occurs in .CONF files & type fart.log %QUIET%&  set FART=1& set CONF=1& if "%QUIET%"=="" pause


goto :EOF



:: ---

:GetFSize
set /a value=0 
set /a sum=0 
set /a sumk=0

FOR /R %1 %%I IN (*) DO ( 
set /a value=%%~zI
set value=!value:~0,-3!
set /a sum=sum+!value!
echo !sum! %%I %%~zI
) 
set /a sum=sum/1000
set value=
goto :EOF

:: ------- GET SYSLINUX VERSION ------

:: SYSLV returns with path of syslinux folder or N=don't install

:SYSLV
set P=
set SYSLV=N
for /R %SPAREVOL%\ %%i in (isolinux.cfg)  DO  if not "%%~zi"=="" set S=%%~zi & if not %%~zi=="" set P=%%~dpi
for /R %SPAREVOL%\ %%i in (syslinux.cfg)  DO  if not "%%~zi"=="" set S=%%~zi & if not %%~zi=="" set P=%%~dpi
if "%P%"=="" goto :EOF

:: Found isolinux.cfg or syslinux.cfg
set SYSLV=.\syslinux\syslinux_4
set P=
set S=0
set D=
set PL=
set SL=0
for /R %SPAREVOL%\ %%i in (vesamenu.c32)  DO  if not "%%~zi"=="" set S=%%~zi & if not %%~zi=="" set P=%%~dpi & if not %%~zi=="" set D=%%~ti
for /R %SPAREVOL%\ %%i in (ldlinux.c32)   DO  if not "%%~zi"=="" set SL=%%~zi & if not %%~zi=="" set PL=%%~dpi & if not %%~zi=="" set DL=%%~ti
:: if no vesamenu then just assume v4
::if "%P%"=="" goto :EOF
::if "%S%"=="" goto :EOF
echo.
echo INSTALL SYSLINUX
echo ================
echo 2010+ = SYSLINUX v3.7 (use if you get a 'not a COM32R image' boot error)
echo 2010+ = SYSLINUX v3.8 (use if you get a 'not a COM32R image' boot error)
echo 2012+ = SYSLINUX v4   (default)
echo 2013+ = SYSLINUX v5 
echo 2013+ = SYSLINUX v6 
echo.
if not "%P%"=="" echo vesamenu.c32 date = %D% & echo.
if %S% LEQ 80000 if %S% GEQ 200 echo INFORMATION: Possibly SysLinux v5/6 detected?
if %S% GEQ 80001 echo INFORMATION: Possibly SysLinux v3 or v4 detected?
if %SL% GEQ 100  echo INFORMATION: SysLinux v5/6 detected.

:New code to detect isolinux.bin version
for /R %SPAREVOL%\ %%i in (isolinux.bin*) do (
	set VER=
	set FVER=
	set IPATH=%%i
:: start with common versions
	if /i "%%~xi"==".bin" findstr /C:"ISOLINUX 3.6" "%%i" > nul && set VER=4&& set FVER=3.6&& goto :GOTVER
	if /i "%%~xi"==".bin" findstr /C:"ISOLINUX 3.7" "%%i" > nul && set VER=4&& set FVER=3.7&& goto :GOTVER
	if /i "%%~xi"==".bin" findstr /C:"ISOLINUX 3.8" "%%i" > nul && set VER=4&& set FVER=3.8&& goto :GOTVER
	if /i "%%~xi"==".bin" findstr /C:"ISOLINUX 4.0" "%%i" > nul && set VER=4&& set FVER=4.0&& goto :GOTVER
	if /i "%%~xi"==".bin" findstr /C:"ISOLINUX 5.1" "%%i" > nul && set VER=5&& set FVER=5.1&& goto :GOTVER
	if /i "%%~xi"==".bin" findstr /C:"ISOLINUX 6.00" "%%i" > nul && set VER=6&& set FVER=6.00&& goto :GOTVER
	if /i "%%~xi"==".bin" findstr /C:"ISOLINUX 6.01" "%%i" > nul && set VER=603&& set FVER=6.01&& goto :GOTVER
	if /i "%%~xi"==".bin" findstr /C:"ISOLINUX 6.02" "%%i" > nul && set VER=603&& set FVER=6.02&& goto :GOTVER
	if /i "%%~xi"==".bin" findstr /C:"ISOLINUX 6.03" "%%i" > nul && set VER=603&& set FVER=6.03&& goto :GOTVER
	if /i "%%~xi"==".bin" findstr /C:"ISOLINUX 6.04" "%%i" > nul && set VER=604&& set FVER=6.04&& goto :GOTVER
	if /i "%%~xi"==".bin" findstr /C:"ISOLINUX 6.0" "%%i" > nul && set VER=6&& set FVER=6.0&& goto :GOTVER

:: less common
	if /i "%%~xi"==".bin" findstr /C:"ISOLINUX 3.5" "%%i" > nul && set VER=4&& set FVER=3.5&& goto :GOTVER
	if /i "%%~xi"==".bin" findstr /C:"ISOLINUX 3.4" "%%i" > nul && set VER=4&& set FVER=3.4&& goto :GOTVER
	if /i "%%~xi"==".bin" findstr /C:"ISOLINUX 3.3" "%%i" > nul && set VER=4&& set FVER=3.3&& goto :GOTVER
	if /i "%%~xi"==".bin" findstr /C:"ISOLINUX 3.2" "%%i" > nul && set VER=4&& set FVER=3.2&& goto :GOTVER
	if /i "%%~xi"==".bin" findstr /C:"ISOLINUX 3.1" "%%i" > nul && set VER=4&& set FVER=3.1&& goto :GOTVER
	if /i "%%~xi"==".bin" findstr /C:"ISOLINUX 3.0" "%%i" > nul && set VER=4&& set FVER=3.0&& goto :GOTVER
)

:GOTVER
:: VER is version to install, FVER is version detected
if not "%VER%"=="" echo ISOLINUX v%FVER% was found in %IPATH%
if not "%VER%"=="" echo. && echo Hint: Suggest use %VER% (press [ENTER] for %VER%)
for /R %SPAREVOL%\ %%i in (syslinux-*.txt) do (
	echo Info: %%i was found
)

set FVER=
set IPATH=
set ask=%VER%
echo.
if "%ask%"=="" if "%AUTOSYSL%"=="Y" set VER=4
:: if user hits ENTER or AUTORUN set, use VER as default
if "%ask%"=="" set ask=4
if not "%AUTOSYSL%"=="Y" set /p ask=Which version of Syslinux shall I install (37,38,4,5,6,603,604,N=None) : 
if "%ask%"=="" goto :GOTVER

echo SYSLINUX=%ask%
set VER=
echo.
set SYSLV=
if "%ask%"=="3" goto :SYSLV
if "%ask%"=="37" set SYSLV=.\syslinux\syslinux_375
if "%ask%"=="3.7" set SYSLV=.\syslinux\syslinux_375
if "%ask%"=="38" set SYSLV=.\syslinux\syslinux_386
if "%ask%"=="3.8" set SYSLV=.\syslinux\syslinux_386
if "%ask%"=="4" set SYSLV=.\syslinux\syslinux_4
if "%ask%"=="5" set SYSLV=.\syslinux\syslinux_5
if "%ask%"=="6" set SYSLV=.\syslinux\syslinux_6
if "%ask%"=="603" set SYSLV=.\syslinux\syslinux_603
if "%ask%"=="6.03" set SYSLV=.\syslinux\syslinux_603
if "%ask%"=="604" set SYSLV=.\syslinux\syslinux_604
if "%ask%"=="6.04" set SYSLV=.\syslinux\syslinux_604
if "%ask%"==""  set SYSLV=.\syslinux\syslinux_4
if /i "%ask%"=="N"  set SYSLV=N
set S=
set P=
set D=
:: delay to let user see chosen version
PING -n 4 127.0.0.1>nul
goto :EOF

:: ---

:getvol:
FOR /F "tokens=2 delims=:" %%? IN ('fsutil fsinfo volumeinfo %1') DO set MYVOL=%%?&&GOTO:GV1
:GV1
set MYVOL=%MYVOL:~1,99%
goto :EOF

:: --- Get spare volume letter ---

:getsparev

::get a free drive letter starting at U:

for /f "usebackq tokens=1*" %%a in (`FSUTIL FSINFO DRIVES ^| find ":"`) do (
if /i "!aa:~1,2!" EQU ":\"  (
  set drives=!drives! %%a
  ) else (
  set drives=!drives! %%b
  )
)

REM don't use a network drive
for %%a in (U T S R Q P O N M L K J I H G F E D V W X Y Z) do (
   echo %drives% | find /i "%%a:\" >nul 2>nul
   if errorlevel 1 (
      net use %%a: >nul 2>nul
      if errorlevel 1 (
         ::echo %%a & pause
         set SPAREVOL=%%a:
         set drives=
         goto :EOF
      )
   )
)


:: ----------

:toupper
REM CONVERT STRING TO UPPERCASE - UC has new string
set UC=%~1
::echo %LC%
FOR /F "tokens=2 delims=-" %%A IN ('FIND "" "%UC%" 2^>^&1') DO SET UpCaseText=%%A
set UC=%UpCaseText:~1,999%
SET UpCaseText=
::echo New string is now: %UC%
goto :EOF

:: ---

