@echo off
REM v1.00 2019-03-12

set BCDfile=%SPAREVOL%\EFI\Microsoft\boot\BCD

if not exist "%BCDfile%" echo ERROR %BCDfile% not found! & pause

REM see http://www.mistyprojects.co.uk/documents/BCDEdit/files/examples3.htm

REM if creating new BCD
REM bcdedit -createstore "%BCDfile%"
REM bcdedit -store "%BCDfile%" -create {bootmgr} /d "Boot Manager"
REM bcdedit -store "%BCDfile%" -create {globalsettings} /d "globalsettings"
REM bcdedit -store "%BCDfile%" -create {dbgsettings} /d "debugsettings"
REM bcdedit -store "%BCDfile%" -create {ramdiskoptions} /d "ramdiskoptions"

REM create new entry in BCD
bcdedit -store "%BCDfile%" -create /d "SWITCH_E2B" -application osloader>GUID.txt
REM Assign GUID to Variable NEWGUID
For /F "tokens=2 delims={}" %%i in (GUID.txt) do (set newguid=%%i)
echo newguid=%newguid%
if exist GUID.txt del GUID.txt
bcdedit -store "%BCDfile%" -set {bootmgr} nointegritychecks ON >nul
bcdedit -store "%BCDfile%" -set {bootmgr} timeout 20 >nul
bcdedit -store "%BCDfile%" -set {bootmgr} displaybootmenu Yes >nul
bcdedit -store "%BCDfile%" -set {%newguid%} bootmenupolicy Legacy >nul

REM Creating ramdisksdidevice entry...
for /f "tokens=2 delims={}" %%g in ('bcdedit /store "%BCDfile%" /create /device') do set ramdisk={%%g}
echo ramdisk gui=%ramdisk%
bcdedit -store "%BCDfile%" -set %ramdisk% ramdisksdidevice boot >nul
bcdedit -store "%BCDfile%" -set %ramdisk% ramdisksdipath \boot\boot.sdi >nul

bcdedit -store "%BCDfile%" -set {%newguid%} device ramdisk=[boot]\sources\switch_x64.wim,%ramdisk% >nul
bcdedit -store "%BCDfile%" -set {%newguid%} path \windows\system32\boot\winload.efi >nul
bcdedit -store "%BCDfile%" -set {%newguid%} osdevice ramdisk=[boot]\sources\switch_x64.wim,%ramdisk% >nul
bcdedit -store "%BCDfile%" -set {%newguid%} systemroot \windows >nul
bcdedit -store "%BCDfile%" -set {%newguid%} winpe yes >nul
bcdedit -store "%BCDfile%" -set {%newguid%} nx optin >nul
bcdedit -store "%BCDfile%" -set {%newguid%} detecthal yes >nul
bcdedit -store "%BCDfile%" -displayorder {%newguid%} -addlast >nul

:: if new store...
REM bcdedit -store "%BCDfile%" -set {bootmgr} device partition=s:
REM bcdedit -store "%BCDfile%" -set {bootmgr} path \EFI\Microsoft\Boot\bootmgfw.efi
REM bcdedit -store "%BCDfile%" -set {bootmgr} locale en-us
REM bcdedit -store "%BCDfile%" /default {%newguid%}
REM bcdedit -store "%BCDfile%" -set {dbgsettings} debugtype Serial
REM bcdedit -store "%BCDfile%" -set {dbgsettings} debugport 1
REM bcdedit -store "%BCDfile%" -set {dbgsettings} baudrate 115200
REM bcdedit -store "%BCDfile%" -set {%newguid%} description "SWITCH_E2B" >nul

:: check BCD
bcdedit /v -store "%BCDfile%" > BCD.log
bcdedit /v -store "%BCDfile%"
find /i BCD.log "SWITCH_E2B" > nul || echo ERROR: Bad BCD was made^^! && pause
find /i BCD.log "SWITCH_x64" > nul || echo ERROR: Bad BCD^^! && pause
if exist BCD.log del BCD.log