REM v0.1 REFIND is called from MakePartImage
@echo.
@echo %~nx0 v1.00

:: REFIND - SOURCE MPI FOLDER STRUCTURE
:: \EFI\boot\refind.cer
:: \EFI\boot\extra\refind_boot_files\bootia32.efi  (refind32)
:: \EFI\boot\extra\refind_boot_files\bootx64.efi   (shim64 which loads grubx64.efi)
:: \EFI\boot\extra\refind_boot_files\grubx64.efi   (refind64)
:: \EFI\boot\extra\refind_boot_files\refind.conf
:: \EFI\boot\extra\refind_boot_files\MokManager.efi
:: \EFI\boot\refind_boot_files\icons
:: \EFI\boot\refind_boot_files\original   (empty)
:: \EFI\boot\refind_boot_files\driversxxx

:: CUSTOM_PE Folder
:: \boot\boot.sdi
:: \EFI\Microsoft\boot\BCD
:: \EFI\boot\extra\SWITCH_x64.efi  (actually Win10 x64 bootmgfw.efi)
:: \sources\SWITCH_x64.wim

:: FINAL DIR STRUCTURE
:: \e2b.efi  - copy of SWITCH_x64.efi for easy loading from EFI Shell command line by user
:: \boot\boot.sdi
:: \sources\SWITCH_x64.wim
:: \EFI\Microsoft\boot\BCD
:: \EFI\boot\MokManager.efi
:: \EFI\boot\bootx64.efi   - shim  1336kb
:: \EFI\boot\grubx64.efi   - rEFInd 204kb
:: \EFI\boot\original\     - original efi boot files - this is real payload xxxKB
:: \EFI\boot\drivers_ia32 and drivers_x64
:: \EFI\boot\extra\SWITCH_x64.efi

:: will launch rEFInd (not Secure Boot) - SHIM=bootx64.efi > grubx64.efi=rEFInd
:: At UEFI-shell, can type e2b to launch WinPE+SWITCH_E2B.exe

if NOT "%DOREFIND%"=="1" goto :skprefind

:: ----- CHECK FOR SECURE BOOT FILE -----
if not exist %SPAREVOL%\EFI\boot\bootx64.efi goto :FF
find /c %SPAREVOL%\EFI\boot\bootx64.efi "Microsoft Root Certificate Authority" > nul || goto :FF
echo.
echo.
echo WARNING: ADDING rEFInd WILL DISABLE SECURE BOOT^^!
echo ================================================
echo.
echo WARNING: The payload may contain a signed 64-bit EFI boot file.
echo.
echo Adding rEFInd will prevent secure booting.
echo To Secure Boot using rEFInd you will need to install the
echo rEFInd Certificate (\refind.cer) using MokManager on first boot.
if exist .\CUSTOM_PE\sources\*.wim if "%DOWIM%"=="1" echo If you want to add the SWITCH_E2B WinPE file, answer Y.
echo.
@echo TIMEOUT IN 10 SECONDS...   (Default=Y)
@echo.
::Ask user with timeout
choice /c NY /N /D Y /T 10 /M "Add rEFInd to image file ([Y]/N)? : "
if not "%ERRORLEVEL%"=="2" goto :skprefind
:FF

:: ----- COPY REFIND FOLDER -----
::move original efi files - rEFInd will find them and show them in menu
if exist %SPAREVOL%\EFI\boot\*.efi XCOPY /hrky %SPAREVOL%\EFI\boot\*.* %SPAREVOL%\EFI\original\*.* > nul
REM rEFInd will display all .efi files in menu, so remove unwanted ones.
if exist %SPAREVOL%\EFI\boot\fde_ld.efi del %SPAREVOL%\EFI\boot\fde_ld.efi > nul
if exist %SPAREVOL%\EFI\boot\boot.efi del %SPAREVOL%\EFI\boot\boot.efi > nul
::MAC boot file will cause VM to boot to it instead of booting to \EFI\boot\bootx64.efi, so rename it
if exist %SPAREVOL%\System\Library\CoreServices\boot.efi ren %SPAREVOL%\System\Library\CoreServices\boot.efi BOOT_MAC.EFI > nul
if exist %SPAREVOL%\System\Library\CoreServices\boot.efi echo INFORMATION: MAC EFI boot file \System\Library\CoreServices\boot.efi was renamed to BOOT_MAC.EFI

::copy \EFI\boot\extra\refind_boot_files to \EFI\boot
XCOPY /herky .\REFIND\EFI\boot\extra\refind_boot_files\*.* %SPAREVOL%\EFI\BOOT\*.* > nul & if errorlevel 1 echo ERROR COPYING REFIND refind_boot_files (maybe not enough space?) & if errorlevel 1 pause & goto :unmount
::copy certificate so user can enroll it with MokManager
COPY .\REFIND\EFI\boot\extra\*.cer %SPAREVOL%\*.* > nul & if errorlevel 1 echo ERROR COPYING *.cer (maybe not enough space?) & if errorlevel 1 pause & goto :unmount
echo. & echo INFORMATION: All files in REFIND folder have been copied.

::CUSTOM_PE FILES
if not exist .\CUSTOM_PE\sources\*.wim goto :skprefind
if NOT "%DOWIM%"=="1" goto :skprefind
::copy windows files
set NEWBCD=
XCOPY /herky .\CUSTOM_PE\boot\*.* %SPAREVOL%\boot\*.* > nul & if errorlevel 1 echo ERROR COPYING CUSTOM_PE\boot FOLDER (maybe not enough space?) & if errorlevel 1 pause & goto :unmount
XCOPY /herky .\CUSTOM_PE\sources\*.* %SPAREVOL%\sources\*.* > nul  & if errorlevel 1 echo ERROR COPYING CUSTOM_PE\sources FOLDER (maybe not enough space?) & if errorlevel 1 pause & goto :unmount
XCOPY /herky .\CUSTOM_PE\EFI\boot\*.* %SPAREVOL%\EFI\boot\*.* > nul  & if errorlevel 1 echo ERROR COPYING CUSTOM_PE\EFI\boot FOLDER (maybe not enough space?) & if errorlevel 1 pause & goto :unmount
if not exist %SPAREVOL%\EFI\Microsoft\boot\BCD set NEWBCD=1 & XCOPY /herky .\CUSTOM_PE\EFI\Microsoft\boot\*.* %SPAREVOL%\EFI\Microsoft\boot\*.* > nul & if errorlevel 1 echo ERROR COPYING CUSTOM_PE\EFI\Microsoft\boot\BCD FILE (maybe not enough space?) & if errorlevel 1 pause & goto :unmount
::copy \EFI\boot\extra\SWITCH_x64.efi (actually bootmgr.efi) to e2b.efi so user can load it easily from shell
COPY .\CUSTOM_PE\EFI\boot\extra\SWITCH_x64.efi %SPAREVOL%\e2b.efi > nul & if errorlevel 1 echo ERROR COPYING CUSTOM_PE\EFI\boot\extra\SWITCH_x64.efi (maybe not enough space?) & if errorlevel 1 pause & goto :unmount

:: Check if BCD already exists - if so add in extra entry for SWITCH_x64 WIM file
if exist %SPAREVOL%\EFI\Microsoft\boot\BCD if "%NEWBCD%"=="" (
	call .\REFIND\AddBCD.cmd
) ELSE (
	echo New BCD file added
)

echo INFORMATION: All files in CUSTOM_PE folder have been copied.
:skprefind

